VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Custom Commands Sample"
   ClientHeight    =   5340
   ClientLeft      =   930
   ClientTop       =   2280
   ClientWidth     =   6690
   LinkTopic       =   "Form1"
   ScaleHeight     =   5340
   ScaleWidth      =   6690
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5160
      TabIndex        =   10
      Top             =   4800
      Width           =   1335
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   3600
      TabIndex        =   9
      Top             =   4800
      Width           =   1335
   End
   Begin VB.CommandButton cmdDelMenu 
      Caption         =   "Delete a Command from Tools Menu"
      Height          =   375
      Left            =   3480
      TabIndex        =   7
      Top             =   4080
      Width           =   2895
   End
   Begin VB.CommandButton cmdDelToolbar 
      Caption         =   "Delete a Command from Toolbar"
      Height          =   375
      Left            =   3480
      TabIndex        =   6
      Top             =   3600
      Width           =   2895
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete a Command"
      Height          =   375
      Left            =   3480
      TabIndex        =   5
      Top             =   3120
      Width           =   2895
   End
   Begin VB.CommandButton cmdAddToolsMenu 
      Caption         =   "Add Command to Tools Menu"
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   4080
      Width           =   2895
   End
   Begin VB.CommandButton cmdAddToolbar 
      Caption         =   "Add Command to Toolbar"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   3600
      Width           =   2895
   End
   Begin VB.CommandButton cmdAddCommand 
      Caption         =   "Add a Command"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   3120
      Width           =   2895
   End
   Begin VB.Frame Frame1 
      Height          =   2655
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6375
      Begin VB.ListBox lstDisplay 
         Height          =   2010
         ItemData        =   "Main.frx":0000
         Left            =   120
         List            =   "Main.frx":0002
         TabIndex        =   1
         Top             =   360
         Width           =   6015
      End
   End
   Begin VB.Frame Frame2 
      Height          =   1695
      Left            =   120
      TabIndex        =   8
      Top             =   2880
      Width           =   6375
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub cmdAddCommand_Click()
'Adds a Custom Command . To add it to the toolbar or Tools Menu , it needs to be added later.
Dim objCommands As Object
Dim ret As Long

'display the New Custom Command dialog
FrmAddCommand.Show 1
 If Not bOK Then
        Exit Sub
 End If
 
lstDisplay.Clear
       
lstDisplay.AddItem "Creating Commands Object"

Set objCommands = CreateObject("ACTOLE.AUXCMDS")

ret = objCommands.AddAuxCommand(FrmAddCommand.txtCmdName, FrmAddCommand.txtCmdLine, FrmAddCommand.txtStartIn, FrmAddCommand.txtTooltip, FrmAddCommand.txtDescription, FrmAddCommand.txtSmallIcon, FrmAddCommand.txtLargeIcon, FrmAddCommand.cboRunState.ListIndex)

If ret <> 0 Then
    lstDisplay.AddItem "Error Adding Custom Command "
Else: lstDisplay.AddItem "Custom Command added successfully"
End If


Set objCommands = Nothing



End Sub


Private Sub cmdAddToolbar_Click()

Dim objCommands As Object
Dim ret As Long
Dim sCommandName As String

sCommandName = InputBox("Please specify the Command Name to be added to the toolbar", "Add Command to Toolbar", "cmdNotepad")

'display the Views Selector dialog
frmViews.Show 1
 If Not bOK Then
        Exit Sub
 End If
 
lstDisplay.Clear
       
lstDisplay.AddItem "Creating Commands Object"

Set objCommands = CreateObject("ACTOLE.AUXCMDS")

If objCommands.AuxCommandExists(sCommandName) Then

    ret = objCommands.AddAuxCommandToToolbar(iView, sCommandName)
    If ret = 0 Then
        lstDisplay.AddItem "Command added to toolbar successfully"
    Else
        lstDisplay.AddItem "Error adding the command to the toolbar"
    End If
Else
    lstDisplay.AddItem "The Command does not exist. Please use the Add a Command button first!"
End If

Set objCommands = Nothing

End Sub


Private Sub cmdAddToolsMenu_Click()

Dim objCommands As Object
Dim ret As Long
Dim sCommandName As String

sCommandName = InputBox("Please specify the Command Name to be added to the Tools Menu", "Add Command to Tools Menu", "cmdNotepad")

'display the Views Selector dialog
frmViews.Show 1
 If Not bOK Then
        Exit Sub
 End If
 
lstDisplay.Clear
       
lstDisplay.AddItem "Creating Commands Object"

Set objCommands = CreateObject("ACTOLE.AUXCMDS")

If objCommands.AuxCommandExists(sCommandName) Then

    ret = objCommands.AddAuxCommandToToolsMenu(iView, sCommandName)
    If ret = 0 Then lstDisplay.AddItem "Command added to Tools Menu successfully!. Please restart ACT to see the results"
    Else: lstDisplay.AddItem "Error adding the command to the Tools Menu"
Else
    lstDisplay.AddItem "The Command does not exist. Please use the Add a Command button first!"

End If

Set objCommands = Nothing
End Sub


Private Sub cmdCancel_Click()
    End
End Sub

Private Sub cmdDelete_Click()

Dim objCommands As Object
Dim ret As Long
Dim sCommandName As String

sCommandName = InputBox("Please specify the Command Name to be deleted", "Delete Command", "cmdNotepad")

lstDisplay.Clear
       
lstDisplay.AddItem "Creating Commands Object"

Set objCommands = CreateObject("ACTOLE.AUXCMDS")

ret = objCommands.DeleteAuxCommand(sCommandName)
If ret = 0 Then
    lstDisplay.AddItem sCommandName & " has been deleted. When ACT restarts , it will not exist in the toolbar or Tools Menu!"
Else
    lstDisplay.AddItem sCommandName & " could not be deleted ."
End If

Set objCommands = Nothing

End Sub


Private Sub cmdDelMenu_Click()
'Deletes the requested command from the Tools Menu of the selected View
Dim objCommands As Object
Dim ret As Long
Dim sCommandName As String

sCommandName = InputBox("Please specify the Command Name to be deleted from Tools Menu", "Delete Command from Tools Menu", "cmdNotepad")

'display the Views Selector dialog
frmViews.Show 1
 If Not bOK Then
        Exit Sub
 End If
 
lstDisplay.Clear
       
lstDisplay.AddItem "Creating Commands Object"

'Create the Commands object
Set objCommands = CreateObject("ACTOLE.AUXCMDS")

'if the Command exists in the toolbar then Remove it from the toolbar
If (objCommands.AuxCommandExistsInToolsMenu(iView, sCommandName)) Then
    ret = objCommands.RemoveAuxCommandFromToolsMenu(iView, sCommandName)
    If ret = 0 Then  ' No error
        lstDisplay.AddItem sCommandName & " has been deleted. When ACT restarts , it will not exist in the toolbar !"
        lstDisplay.AddItem "The Command still exists. To delete it completely , you need to select the Delete Command button."
    Else ' error
        lstDisplay.AddItem sCommandName & " could not be deleted ."
    End If
Else
    lstDisplay.AddItem sCommandName & " does not exist in the toolbar in the View selected, Please try again"
End If
    
Set objCommands = Nothing
End Sub

Private Sub cmdDelToolbar_Click()
'Deletes the requested command from the toolbar of the selected View
Dim objCommands As Object
Dim ret As Long
Dim sCommandName As String

sCommandName = InputBox("Please specify the Command Name to be deleted from Toolbar", "Delete Command from Toolbar", "cmdNotepad")

'display the Views Selector dialog
frmViews.Show 1
 If Not bOK Then
        Exit Sub
 End If
 
lstDisplay.Clear
       
lstDisplay.AddItem "Creating Commands Object"

'Create the Commands object
Set objCommands = CreateObject("ACTOLE.AUXCMDS")

'if the Command exists in the toolbar then Remove it from the toolbar
If (objCommands.AuxCommandExistsInToolbar(iView, sCommandName)) Then
    ret = objCommands.RemoveAuxCommandFromToolbar(iView, sCommandName)
    If ret = 0 Then  ' No error
        lstDisplay.AddItem sCommandName & " has been deleted. When ACT restarts , it will not exist in the toolbar !"
        lstDisplay.AddItem "The Command still exists. "
        lstDisplay.AddItem "To delete it completely , you need to select the Delete Command button."
    Else ' error
        lstDisplay.AddItem sCommandName & " could not be deleted ."
    End If
Else
    lstDisplay.AddItem sCommandName & " does not exist in the toolbar in the View selected, Please try again"
End If
    
Set objCommands = Nothing
End Sub


Private Sub cmdOK_Click()
    End
End Sub


