// ActCmdExample.h : main header file for the ACTCMDEXAMPLE application
//

#if !defined(AFX_ACTCMDEXAMPLE_H__5A376939_4F46_11D3_B3E2_005004055C8A__INCLUDED_)
#define AFX_ACTCMDEXAMPLE_H__5A376939_4F46_11D3_B3E2_005004055C8A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

/////////////////////////////////////////////////////////////////////////////
// CActCmdExampleApp:
// See ActCmdExample.cpp for the implementation of this class
//

class CActCmdExampleApp : public CWinApp
{
public:
    CActCmdExampleApp() {}

	virtual BOOL InitInstance();
};


/////////////////////////////////////////////////////////////////////////////
// Definition of CActPathDlg, a dialog that gets the ACT! directory from user

class CPathDlg : public CDialog
{
public:
    CPathDlg(CWnd* pParent = NULL);	// standard constructor
    virtual ~CPathDlg();

    int DoModal(CString *pSActPath);
    void SetStaticMsg(LPCTSTR lpcMsg);
    void SetDefaultPath(LPCTSTR lpcDefPath);
    
    // Implementation
protected:
    virtual BOOL OnInitDialog();
    virtual void OnOK();
    virtual void OnCancel();

    DECLARE_MESSAGE_MAP()

private:
    CString *m_pSPath;
    CString m_sStaticMsg;
    CString m_sDefaultPath;
};

#endif // !defined(AFX_ACTCMDEXAMPLE_H__5A376939_4F46_11D3_B3E2_005004055C8A__INCLUDED_)
