VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Activities Sample"
   ClientHeight    =   3960
   ClientLeft      =   1545
   ClientTop       =   2655
   ClientWidth     =   6690
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3960
   ScaleWidth      =   6690
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdReload 
      Caption         =   "Reload Database"
      Height          =   372
      Left            =   3360
      TabIndex        =   3
      Top             =   3360
      Width           =   1452
   End
   Begin VB.TextBox txtDBName 
      Height          =   288
      Left            =   120
      TabIndex        =   2
      Top             =   3360
      Width           =   3132
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   372
      Left            =   5400
      TabIndex        =   1
      Top             =   3360
      Width           =   1092
   End
   Begin VB.ListBox lstDisplay 
      Height          =   4155
      ItemData        =   "ActivityMain.frx":0000
      Left            =   0
      List            =   "ActivityMain.frx":0002
      TabIndex        =   0
      Top             =   -1080
      Width           =   6615
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "Edit"
      Begin VB.Menu mnuScheduleActivity 
         Caption         =   "Schedule an Activity ** Updated for ACT2000"
      End
      Begin VB.Menu mnuSchdActmulticont 
         Caption         =   "Schedule an activity with multiple contacts  "
      End
      Begin VB.Menu mnuAddException 
         Caption         =   "Add an Exception Date"
      End
      Begin VB.Menu mnuDeleteException 
         Caption         =   "Delete an Exception Date"
      End
      Begin VB.Menu mnuClearActivities 
         Caption         =   "Clear Old Activities"
      End
      Begin VB.Menu mnuUnclear 
         Caption         =   "Unclear Activities"
      End
   End
   Begin VB.Menu mnuList 
      Caption         =   "List"
      Begin VB.Menu mnuListActivities 
         Caption         =   "List All Activities **Updated for ACT!2000"
      End
      Begin VB.Menu mnuListRecurringActivities 
         Caption         =   "List Recurring Activities"
      End
      Begin VB.Menu mnuFieldSchemaList 
         Caption         =   "Field Schema List"
      End
   End
   Begin VB.Menu mnuPopUp 
      Caption         =   "PopUp "
      Begin VB.Menu mnuListDropDownItems 
         Caption         =   "List  Regarding  DropDown List Items"
      End
      Begin VB.Menu mnuAddPopUp 
         Caption         =   "Add an Item to Regarding"
      End
   End
   Begin VB.Menu mnuBrowse 
      Caption         =   "Browse"
      Begin VB.Menu mnuBrowseRec 
         Caption         =   "Browse Records"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False




Private Sub cmdExit_Click()
  End
End Sub






Private Sub cmdReload_Click()
     'This function reloads the database if
     'the database is changed by the user
     
    dbName = txtDBName.Text
    MsgBox "The database has changed"
    
    'The Contact Picker form needs to be reloaded
    Unload frmContactPicker
    frmContactPicker.Hide
    'The Browser form needs to be unloaded
    Unload frmBrowse
    
End Sub


Private Sub Form_Load()
    dbName = "C:\PROGRAM FILES\ACT\DATABASE\ACT5DEMO.DBF"
    txtDBName.Text = dbName
    bAlreadyLoggedIn = False
End Sub











Function EndTime() As String
'This function calculates the EndTime for an Activity

Dim strStartTime As String
Dim strEndTime As String
Dim strampm As String
Dim ihour As Integer
Dim iDuration As Integer
Dim iminute As Integer
Dim iEndMinute As Integer
Dim iPos As Integer


    strStartTime = frmSchedule.cboTime
    iDuration = frmSchedule.cboDuration
    
    iPos = InStr(1, strStartTime, ":", 1)
   
    strampm = Right(strStartTime, 2)  'Get AM or PM
    strStartTime = Mid(strStartTime, 1, iPos + 2)
    ihour = Left(strStartTime, iPos - 1)  'Get hours
    iminute = Right(strStartTime, 2)  'get minutes

    iEndMinute = iminute + iDuration
    If iEndMinute < 60 Then
        EndTime = ihour & ":" & iEndMinute & " " & ampm  'Calculate end time
    Else
        ihour = ihour + 1   'increase hour by 1
        iEndMinute = iEndMinute - 60
        If ihour > 11 Then    'To set AM/PM
            If strampm = "AM" Then
                strampm = "PM"
            ElseIf strampm = "PM" Then
                strampm = "AM"
            End If
            If ihour > 12 Then  'To set 1 after 12
                ihour = ihour - 12
            End If
        End If
        If iEndMinute > 0 Then
            EndTime = ihour & ":" & iEndMinute & strampm
        Else ' iEndMinute is 0
            EndTime = ihour & ":" & iEndMinute & "0" & strampm
        End If
   
    End If
End Function

Private Sub mnuAlarm_Click()

End Sub

Private Sub mnuAddException_Click()
' Add an exception date for all recurring activities
Dim objDatabase As Object
Dim objActivity As Object
Dim lcounter As Long
Dim iRecordCount As Integer
Dim strExceptionDate As String
Dim strMsg As String
Dim strDefault As String

    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation routines
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    'Get the exception date
    strDefault = "7/4/97"
    strMsg = "Please enter a date on which you do not want the recurring activities to occur!"
    strExceptionDate = InputBox(strMsg, "Exception Information", strDefault)
    
    ' assign the correct table object
    Set objActivity = objDatabase.Activity
    If objDatabase.IsOpen Then
        lstDisplay.AddItem "Record Count = " & objActivity.RecordCount
        lstDisplay.AddItem " "
        
        'Go through all activity records. If the activity is recurring add the exception date
        objActivity.MoveFirst
        iRecordCount = 0
        While Not objActivity.IsEOF
            iRecordCount = iRecordCount + 1
            If objActivity.IsRecurring Then
                ' Add the Exception date
               objActivity.ExceptionInfo.Add strExceptionDate
            End If
            objActivity.MoveNext
        Wend
        lstDisplay.AddItem strExceptionDate & " no longer has an activity scheduled."
        Set objActivity = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"

    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub mnuAddPopUp_Click()
'Adds an item in the Regarding DropDown List box
Dim objDatabase As Object
Dim objPopUpInfo As Object
Dim objActivity As Object
Dim iCount As Integer
Dim i As Integer
Dim txtRemark As String

    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    frmAddPopUp.Show 1
    txtRemark = frmAddPopUp.txtRemark.Text
    
    'if the text box in the Popup Form is blank exit the function without doing anything
    If txtRemark = "" Then
        MsgBox "Nothing entered to add!"
        Exit Sub
    End If
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
       
    Set objActivity = objDatabase.Activity
    If objDatabase.IsOpen Then
       
        If frmAddPopUp.optCall.Value = True Then 'the Call Type Option button was selected
          
            Set objPopUpInfo = objActivity.Fields.PopupInfo(AF_Regarding, 0)
            objPopUpInfo.Add txtRemark, "" 'Add an item to the Call list box
            lstDisplay.AddItem txtRemark & " Added for Type Call. "
                         
         ElseIf frmAddPopUp.optMeeting.Value = True Then  'Meeting type Option button selected
            Set objPopUpInfo = objActivity.Fields.PopupInfo(AF_Regarding, 1)
            objPopUpInfo.Add txtRemark, ""  'Add an item to the Meeting list box
            lstDisplay.AddItem txtRemark & " Added for Type Meeting. "
                    
        ElseIf frmAddPopUp.optTodo.Value = True Then   'ToDo type Option button selected
            Set objPopUpInfo = objActivity.Fields.PopupInfo(AF_Regarding, 2)
            objPopUpInfo.Add txtRemark, ""  'Add an item to the ToDo list box
            lstDisplay.AddItem txtRemark & " Added for Type Todo. "
        End If
        
        Set objPopUpInfo = Nothing
        Set objActivity = Nothing
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
 
End Sub

Private Sub mnuBrowseRec_Click()
'Show the Activity Browser form
    frmBrowse.Show 1
End Sub

Private Sub mnuClearActivities_Click()
'This function Clears all Activities whose EndTime is before The time Now
Dim objDatabase As Object
Dim objActivity As Object
Dim uniqueID As String
  
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    Set objActivity = objDatabase.Activity
    
    'Go through all the activities ,if the end-time is before Now then clear it
    If objDatabase.IsOpen Then
        objActivity.MoveFirst
        While Not objActivity.IsEOF
               If objActivity.Data(AF_EndTime) < Now Then
                objActivity.Clear
               End If
            objActivity.MoveNext
        Wend
        lstDisplay.AddItem "Cleared all activities whose End time was before now"
        Set objActivity = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
  ' clear the object
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub mnuDeleteException_Click()
' Remove an exception date for all activities
Dim objDatabase As Object
Dim objActivity As Object
Dim lcounter As Long
Dim iRecordCount As Integer
Dim strExceptionDate As String
Dim strMsg As String
Dim strDefault As String
 
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation routines
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    'Get the exception date
    strMsg = "Please enter a date for which you do not want the exception!"
    strDefault = "7/4/97"
    strExceptionDate = InputBox(strMsg, "Exception Information", strDefault)
    
    ' assign the correct table object
    Set objActivity = objDatabase.Activity
    If objDatabase.IsOpen Then
        lstDisplay.AddItem "Record Count = " & objActivity.RecordCount
        lstDisplay.AddItem " "
        
       'Go through all activity records. If the activity is recurring delete the exception date
        objActivity.MoveFirst
        iRecordCount = 0
        While Not objActivity.IsEOF
            iRecordCount = iRecordCount + 1
            If objActivity.IsRecurring Then
                ' Remove the Exception date
                objActivity.ExceptionInfo.Remove strExceptionDate
            End If
            objActivity.MoveNext
        Wend
        lstDisplay.AddItem strExceptionDate & " no longer has an exception."
        Set objActivity = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
        
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub mnuFieldSchemaList_Click()
'This function lists the field schema for all the fields
'in the Activity Object.

 Dim objDatabase As Object
 Dim objActivity As Object
 Dim lcounter As Long
 Dim strOut As String
 Dim iFieldId As String
 
    lstDisplay.Clear
    lstDisplay.AddItem "*** Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
                
    lstDisplay.AddItem "*** Opening Database"
    objDatabase.Open dbName
    lstDisplay.AddItem "*** Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
                
    ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    'Check if version of the ACTOLE.dll is  3.06 or greater (3.05 returns a 1 )
    If objDatabase.MajorVersion = 1 Then
       MsgBox "You have an ACTOLE.dll older than version 3.06." & Chr(13) & "This function needs the new features. Please Update and Retry!  "
       lstDisplay.Clear
       objDatabase.Close
       Exit Sub
    End If
    If objDatabase.IsOpen Then
                
    ' assign the object
        Set objActivity = objDatabase.Activity
        lstDisplay.AddItem "Name: " & objDatabase.Name
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Record count: " & objActivity.RecordCount
        lstDisplay.AddItem "Field Count : " & objActivity.FieldCount
        lstDisplay.AddItem "Table Name : " & objActivity.Name
        lstDisplay.AddItem ""
    
        For lcounter = 0 To objActivity.Fields.Count()
            'List all properties for each field
            strOut = ""
            If (objActivity.Fields.FieldIdAt(lcounter) <> -1) Then
                iFieldId = objActivity.Fields.FieldIdAt(lcounter)
                strOut = strOut + "* Field " & ": " & " FIELD ID=" & objActivity.Fields.FieldIdAt(lcounter)
                strOut = strOut + " " & "Label=" & objActivity.Fields.Label(iFieldId)
                strOut = strOut + ", Type: " & objActivity.Fields.Type(iFieldId)
                strOut = strOut + ", Length: " & objActivity.Fields.length(iFieldId)
                         
                lstDisplay.AddItem strOut
                strOut = ""
                strOut = strOut + "   Indexed:" & objActivity.Fields.IsIndexed(iFieldId)
                strOut = strOut + ", Initial Value:" & objActivity.Fields.InitialValue(iFieldId)
                strOut = strOut + ", Sortable:" & objActivity.Fields.IsSortable(iFieldId)
                strOut = strOut + ", Modifiable:" & objActivity.Fields.Modifiable(iFieldId)
                strOut = strOut + ", PopupList:" & objActivity.Fields.HasPopupList(iFieldId)
                lstDisplay.AddItem strOut
                         
                strOut = ""
                strOut = strOut + "   EntryTrigger=" & objActivity.Fields.EntryTrigger(iFieldId)
                strOut = strOut + ", ExitTrigger=" & objActivity.Fields.ExitTrigger(iFieldId)
                lstDisplay.AddItem strOut
                lstDisplay.AddItem ""
            End If
        Next
    Set objActivity = Nothing
    lstDisplay.AddItem "*** Closing Database"
    objDatabase.Close
    lstDisplay.AddItem "*** Database Closed"
    End If

    Set objDatabase = Nothing
    lstDisplay.SetFocus
    
End Sub

Private Sub mnuListActivities_Click()
'This Function lists all the activities , their details  and all the contacts it is associated with
'Updated for ACT! 2000

Dim objDatabase As Object
Dim lcounter As Long
Dim strContactID As String
Dim iPosition As Integer
Dim objActivity As Object
Dim objContact As Object
Dim uniqueID As String
Dim bMatch As Boolean

    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table objects
   
    Set objActivity = objDatabase.Activity
    Set objContact = objDatabase.Contact
    If objDatabase.IsOpen Then
        If Val(objDatabase.Version) < 4 Then
            lstDisplay.AddItem "A version older than ACT! 4.0 has been detected ! "
            lstDisplay.AddItem "Please upgrade to get all the contacts an activity is associated with"
            lstDisplay.AddItem ""
        End If
        If Val(objDatabase.Version) < 5 Then
            lstDisplay.AddItem "A version older than ACT! 2000 has been detected ! "
            lstDisplay.AddItem "Please upgrade to get the activity details."
            lstDisplay.AddItem ""
        End If
        objActivity.MoveFirst
            While Not objActivity.IsEOF
              If (objActivity.IsClear <> True) Then   'List only activities which are not cleared
                     bMatch = False
                    uniqueID = objActivity.FirstScheduledWith  'Get the contactId for an activity
                    objContact.MoveFirst
                    Do
                        ' compare the search id with the first scheduled with id
                        ' if they match then we have an activity for the search id.
                        strContactID = objContact.Data(CF_UniqueID)
                         If uniqueID = strContactID Then
                           lstDisplay.AddItem "ACTIVITY Scheduled With   : " & objContact.Data(CF_Name)
                           bMatch = True
                           Exit Do
                         End If
                         objContact.MoveNext
                   Loop While Not bMatch
                    Dim i As Integer
                    i = 0
                    If Val(objDatabase.Version) >= 4 Then
                        Do
                            bMatch = False
                            uniqueID = objActivity.NextScheduledWith
                            If uniqueID = "" Then Exit Do
                            
                            objContact.MoveFirst
                            Do
                            ' compare the search id with the next scheduled with id
                            ' if they match then we have an activity for the search id.
                                strContactID = objContact.Data(CF_UniqueID)
                                If uniqueID = strContactID Then
                                    lstDisplay.AddItem "ACTIVITY Next Scheduled With   : " & objContact.Data(CF_Name)
                                    bMatch = True
                                    Exit Do 'If you have a match exit the loop
                                End If
                                objContact.MoveNext
                            Loop While Not bMatch
                        Loop While (uniqueID <> "")
                    
                    End If
                    lstDisplay.AddItem "ACTIVITY Regarding   : " & objActivity.Data(AF_Regarding)
                    lstDisplay.AddItem "ACTIVITY Start Time  : " & objActivity.Data(AF_StartTime)
                    lstDisplay.AddItem "ACTIVITY End Time    : " & objActivity.Data(AF_EndTime)
                    'if the database object version is 5 or later
                    If Val(objDatabase.Version) >= 5 Then
                        'if the particular activity has details associated with it
                        If objActivity.HasDetails = True Then
                            lstDisplay.AddItem "ACTIVITY Details    : " & objActivity.Data(AF_Details)
                        End If
                    End If
                    lstDisplay.AddItem "-------------------------------------------------------"
              End If
              objActivity.MoveNext
        Wend
        Set objContact = Nothing
        Set objActivity = Nothing
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub


Private Sub mnuListDropDownItems_Click()
'List all the Items in the Regarding Drop Down List box
Dim objDatabase As Object
Dim objPopUpInfo As Object
Dim objActivity As Object
Dim iCount As Integer
Dim i As Integer

' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    Set objActivity = objDatabase.Activity
    If objDatabase.IsOpen Then
        'List the DropDown Items for the regarding listbox for Activity Type CALL.
        'Set the PopUpInfo Object for Activity Type CALL.
        Set objPopUpInfo = objActivity.Fields.PopupInfo(AF_Regarding, 0)
        lstDisplay.AddItem "Regarding Listbox has following items for Type Call: "
        iCount = objPopUpInfo.PopupCount   'Number of items in the popup list
        For i = 1 To iCount
            lstDisplay.AddItem "Remark: " & objPopUpInfo.Remark(i)
            lstDisplay.AddItem "Value: " & objPopUpInfo.Value(i)
        Next i
        lstDisplay.AddItem "-------------------------------------------------------- "
         
        'List the DropDown Items for the regarding listbox for Activity Type MEETING.
        'Set the PopUpInfo Object for Activity Type MEETING.
        Set objPopUpInfo = objActivity.Fields.PopupInfo(AF_Regarding, 1)
        lstDisplay.AddItem "Regarding Listbox has following items for Type Meeting: "
        iCount = objPopUpInfo.PopupCount 'Number of items in the popup list
        For i = 1 To iCount
            lstDisplay.AddItem "Remark: " & objPopUpInfo.Remark(i)
            lstDisplay.AddItem "Value: " & objPopUpInfo.Value(i)
        Next i
        lstDisplay.AddItem "------------------------------------------------------"
         
        'List the DropDown Items for the regarding listbox for Activity Type TODO.
        'Set the PopUpInfo Object for Activity Type TODO.
        Set objPopUpInfo = objActivity.Fields.PopupInfo(AF_Regarding, 2)
        lstDisplay.AddItem "Regarding Listbox has following items for Type ToDo: "
        iCount = objPopUpInfo.PopupCount 'Number of items in the popup list
        For i = 1 To iCount
            lstDisplay.AddItem "Remark: " & objPopUpInfo.Remark(i)
            lstDisplay.AddItem "Value: " & objPopUpInfo.Value(i)
        Next i
        lstDisplay.AddItem "------------------------------------------------------"
          
        Set objPopUpInfo = Nothing
        Set objActivity = Nothing
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
   
End Sub

Private Sub mnuListRecurringActivities_Click()
' list all recurring activities
Dim objDatabase As Object
Dim objActivity As Object
Dim lcounter As Long
Dim iRecordCount As Integer
Dim iFieldId As Integer
Dim iLength As Integer
Dim iFrequency As Integer
Dim iDaysOfWeek As Long
Dim iDaysOfMonth As Long
Dim iWeeksOfMonth As Long
Dim iRecurtype As Integer
Dim strdaysofweek As String
Dim strweeksofmonth As String
Dim iDayvalue As Long
Dim strOut As String
  
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation routines
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    ' assign the correct table object
    Set objActivity = objDatabase.Activity
    If objDatabase.IsOpen Then
        If objDatabase.MajorVersion = 1 Then
             MsgBox "You have an ACTOLE.dll older than version 3.06." & Chr(13) & "Please Update!"
        End If
        lstDisplay.AddItem "Record Count = " & objActivity.RecordCount
        lstDisplay.AddItem " "
        ' enumerate all of the records in the table
        objActivity.MoveFirst
        iRecordCount = 0
        
        While Not objActivity.IsEOF
            iRecordCount = iRecordCount + 1
            If objActivity.IsRecurring Then
                lstDisplay.AddItem "Rec#: " & iRecordCount
                iRecurtype = objActivity.recurringType
                lstDisplay.AddItem "Recurring=" & objActivity.IsRecurring
                
                ' print out any exception info for that activity
                lstDisplay.AddItem "There are :" & objActivity.ExceptionInfo.Count & " exceptions."
                If objActivity.ExceptionInfo.Count > 0 Then
                    Dim counter As Integer
                    For counter = 1 To objActivity.ExceptionInfo.Count
                        lstDisplay.AddItem "Exception #" & counter & " = " & objActivity.ExceptionInfo.Value(counter)
                    Next counter
                End If
                'Get the Recurring Type and evaluate further on each type
                Select Case iRecurtype
                    Case recurring_none
                        lstDisplay.AddItem "No recurring information"
                        
                    Case recurring_days
                        lstDisplay.AddItem "Recurring type = Daily"
                        lstDisplay.AddItem "Recurring Every " & objActivity.GetRecurringFrequency() & " Days"
                        
                    Case recurring_weekdays
                        lstDisplay.AddItem "Recurring type: Days of the Week"
                        iDaysOfWeek = objActivity.GetDaysOfWeekBits()
                        lstDisplay.AddItem "Recurring Every " & objActivity.GetRecurringFrequency() & " Weeks"
                    
                    Case recurring_daysofmonth
                        lstDisplay.AddItem "Recurring type: Days of the Month"
                        lstDisplay.AddItem "Recurring Every " & objActivity.GetRecurringFrequency() & " Months"
                        iDaysOfMonth = objActivity.GetDaysOfMonthBits()
                    
                    Case recurring_daysandweeksofmonth
                        lstDisplay.AddItem "Recurring type: Days and Weeks of the month"
                        iDaysOfWeek = objActivity.GetDaysOfWeekBits()
                        iWeeksOfMonth = objActivity.GetWeeksOfMonthBits()
                        lstDisplay.AddItem "Recurring Every: " & objActivity.GetRecurringFrequency() & " Months"
                End Select
                                        
                iDaysOfWeek = objActivity.GetDaysOfWeekBits()
                iWeeksOfMonth = objActivity.GetWeeksOfMonthBits()
                lstDisplay.AddItem "Recurring until: " & objActivity.GetRecurringUntilDate()

                strdaysofweek = ""
                strweeksofmonth = ""
                
                ' parse the days of the week bits
                If iDaysOfWeek And day_sunday Then
                    strdaysofweek = strdaysofweek + "Sunday,"
                End If
                
                If iDaysOfWeek And day_monday Then
                    strdaysofweek = strdaysofweek + "Monday,"
                End If
                
                If iDaysOfWeek And day_tuesday Then
                    strdaysofweek = strdaysofweek + "Tuesday,"
                End If
                
                If iDaysOfWeek And day_wednesday Then
                    strdaysofweek = strdaysofweek + "Wednesday,"
                End If
                
                If iDaysOfWeek And day_thursday Then
                    strdaysofweek = strdaysofweek + "Thursday,"
                End If
                
                If iDaysOfWeek And day_friday Then
                    strdaysofweek = strdaysofweek + "Friday,"
                End If
                
                If iDaysOfWeek And day_saturday Then
                    strdaysofweek = strdaysofweek + "Saturday"
                End If
                
                ' parse the weeks of the month bits
                If iWeeksOfMonth And week_one Then
                    strweeksofmonth = strweeksofmonth + "One,"
                End If
                
                If iWeeksOfMonth And week_two Then
                    strweeksofmonth = strweeksofmonth + "Two,"
                End If
                
                If iWeeksOfMonth And week_three Then
                    strweeksofmonth = strweeksofmonth + "Three,"
                End If
                
                If iWeeksOfMonth And week_four Then
                    strweeksofmonth = strweeksofmonth + "Four,"
                End If
                
                If iWeeksOfMonth And week_last Then
                    strweeksofmonth = strweeksofmonth + "Last"
                End If
                
                If iRecurtype = recurring_weekdays Then
                    lstDisplay.AddItem "Days of Week: " & strdaysofweek
                End If
                                
                If iRecurtype = recurring_daysandweeksofmonth Then
                    lstDisplay.AddItem "Days of Week: " & strdaysofweek
                    lstDisplay.AddItem "Weeks of Month: " & strweeksofmonth
                End If
                
                ' parse the days of the month bits
                outString = ""
                If iRecurtype = recurring_daysofmonth Then
                    Dim i As Integer
                    For i = 0 To 30
                        iDayvalue = 2 ^ i
                      
                        If daysOfMonth And dayvalue Then
                            strOut = strOut & (i + 1) & ","
                        End If
                    Next i
                    lstDisplay.AddItem "Days of the Month: " & strOut
                End If
            
                lstDisplay.AddItem "Cleared=" & objActivity.IsClear
                lstDisplay.AddItem "Timeless=" & objActivity.IsTimeless
                lstDisplay.AddItem "Has Alarms=" & objActivity.HasAlarm
            
                ' enumerate all fields in this record
                 
               If objDatabase.MajorVersion <> 1 Then
                    For lcounter = 1 To objActivity.Fields.Count
                        iFieldId = objActivity.Fields.FieldIdAt(lcounter)
                        length = Len(objActivity.Data(objActivity.Fields.FieldIdAt(lcounter)))
                        If (length > 0) Then
                            lstDisplay.AddItem objActivity.Fields.Label(iFieldId) & " : " & objActivity.Data(objActivity.Fields.Id(iFieldId))
                        End If
                    Next
                    lstDisplay.AddItem "-------------"
               Else
                   
                    lstDisplay.AddItem "ACTIVITY Regarding   : " & objActivity.Data(AF_Regarding)
                    lstDisplay.AddItem "ACTIVITY Start Time  : " & objActivity.Data(AF_StartTime)
                    lstDisplay.AddItem "ACTIVITY End Time    : " & objActivity.Data(AF_EndTime)
                    lstDisplay.AddItem "---------------------------------------------------"
               End If
            End If
            objActivity.MoveNext
        Wend
        Set objActivity = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
        
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub mnuSchdActmulticont_Click()
'Function to Schedule an Activity for a Multiple Contacts.
'An activity is scheduled with Yourself(Current User) and  two selected contacts

Dim objDatabase As Object
Dim lcounter As Long
Dim strUniqueID As String
Dim lDayBits As Long
Dim lWeekBits As Long
Dim strdate As String
Dim strEndTime As String
Dim objUsers As Object
Dim sMyUID As String

    bMult = True   'Multi Contact
    lstDisplay.Clear
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If Val(objDatabase.Version) < 4 Then
        MsgBox "You need at least ACT! 4.0 is installed ,Please Upgrade"
        Exit Sub
    End If
    
     ' display the Schedule an activity dialog dialog
    bOK = False
    frmSchedule.Show 1
    If Not bOK Then
        Exit Sub
    End If
    
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        Set objUsers = objDatabase.Users  'Create the users object
        sMyUID = objUsers.CurrentUserId   'Get the uniqueId of the MyRecord
        ' allocate a new record
        objDatabase.Activity.Add
                  
        ' set the TIME FIELDS (critical formatting required)
        strdate = frmSchedule.txtActivityMonth & "/" & frmSchedule.txtActivityDay & "/" & frmSchedule.txtActivityYear
               
        ' DATE/TIME FORMATTING IS VERY STRICT
        objDatabase.Activity.Data AF_StartTime, DateValue(strdate) & " " & frmSchedule.cboTime
        objDatabase.Activity.Data AF_Duration, frmSchedule.cboDuration
        strEndTime = EndTime()
        objDatabase.Activity.Data AF_EndTime, DateValue(strdate) & " " & strEndTime
      
        ' set the MISCELLANEOUS FIELDS
        objDatabase.Activity.Data AF_Regarding, frmSchedule.txtRegarding
        objDatabase.Activity.Data AF_BannerColor, RGB(0, 0, 255)
        
        ' set the priority
        If UCase(frmSchedule.cboPriority) = "LOW" Then
            objDatabase.Activity.Data AF_Priority, activitypriority_low
        End If
        If UCase(frmSchedule.cboPriority) = "MEDIUM" Then
            objDatabase.Activity.Data AF_Priority, activitypriority_medium
        End If
        If UCase(frmSchedule.cboPriority) = "HIGH" Then
            objDatabase.Activity.Data AF_Priority, activitypriority_high
        End If
        
        ' set the ACTIVITY TYPE
        If UCase(frmSchedule.cboActivitytype) = "CALL" Then
            objDatabase.Activity.Data AF_Type, activitytype_call
        End If
        If UCase(frmSchedule.cboActivitytype) = "MEETING" Then
            objDatabase.Activity.Data AF_Type, activitytype_meeting
        End If
        If UCase(frmSchedule.cboActivitytype) = "TODO" Then
            objDatabase.Activity.Data AF_Type, activitytype_todo
        End If
        
        'Set Private/Public
        If frmSchedule.chkPrivate Then
            objDatabase.Activity.Data AF_PublicPrivate, "2"
        Else
            objDatabase.Activity.Data AF_PublicPrivate, "1"
        End If
        
        'Set SendEmail
        If frmSchedule.chkSendEmail Then
            objDatabase.Activity.Data AF_EmailStatus, "1"
        Else
            objDatabase.Activity.Data AF_EmailStatus, "0"
        End If
        
        'if the version of ACT is 5.0 or greater then Add details to the activity
        If Val(objDatabase.Version) > 4 Then
            objDatabase.Activity.Data AF_Details, frmAddDetail.txtDetail.Text
        End If
        
        'Set the Alarm
        If frmSchedule.chkSetAlarm Then
            objDatabase.Activity.Data AF_AlarmStatus, "1"
            objDatabase.Activity.Data AF_LeadTime, frmSchedule.cboLeadtime
        Else
            objDatabase.Activity.Data AF_AlarmStatus, "0"
            objDatabase.Activity.Data AF_LeadTime, "0"
        End If
        lstDisplay.AddItem ""
        lstDisplay.AddItem "*** Activity Added!!!"
        lstDisplay.AddItem ""
        
        ' update the records contents (This has to be done)
        uniqueID = objDatabase.Activity.Update
        objDatabase.Activity.GoTo (uniqueID)
        
        'Check to see if the activity is Recurring and then if so make it recurring.
        If iRecurring = recurring_days Then
            objDatabase.Activity.SetRecurringDays frmRecurringDays.txtDays, frmRecurringDays.txtEndDate
        ElseIf iRecurring = recurring_weekdays Then
            lDayBits = idayBits(1) Or idayBits(2) Or idayBits(3) Or idayBits(4) Or idayBits(5) Or idayBits(6) Or idayBits(7)
            objDatabase.Activity.SetRecurringWeekDays frmRecurringWeek.txtFrequency, lDayBits, DateValue(frmRecurringWeek.txtEndDate.Text)
        ElseIf iRecurring = recurring_daysofmonth Then
            lWeekBits = iweekBits(1) Or iweekBits(2) Or iweekBits(3) Or iweekBits(4) Or iweekBits(5)
            lDayBits = idayBits(1) Or idayBits(2) Or idayBits(3) Or idayBits(4) Or idayBits(5) Or idayBits(6) Or idayBits(7)
            objDatabase.Activity.SetRecurringDaysAndWeeksofMonth frmRecurringMonth.txtFrequency.Text, lDayBits, lWeekBits, DateValue(frmRecurringMonth.txtEndDate.Text)
        End If
       
        'If there is an error check what the error is
        If objDatabase.Activity.Error Then
            MsgBox objDatabase.Activity.LastError
        End If
        
        ' make the association between the contacts and the activity (very important).
        objDatabase.Activity.GoTo (uniqueID)
        objDatabase.Activity.FirstScheduledWith (frmSchedule.txtScheduledwith)  'First Contact
         objDatabase.Activity.NextScheduledWith (frmSchedule.txtScheduledWith1) 'Next Contact
          objDatabase.Activity.NextScheduledWith sMyUID  'Schedule the activity with me
               
        'If there is an error check what the error is
        If objDatabase.Activity.Error Then
            MsgBox objDatabase.Activity.LastError
        End If
        
        Set objUsers = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object

    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub mnuScheduleActivity_Click()
'Function to Schedule an Activity for a particular Contact.

Dim objDatabase As Object
Dim lcounter As Long
Dim strUniqueID As String
Dim lDayBits As Long
Dim lWeekBits As Long
Dim strdate As String
Dim strEndTime As String
    bMult = False    'Not a multi contact scheduling sample
    ' display the add new contact dialog
    bOK = False
    frmSchedule.txtScheduledWith1.Visible = False
     frmSchedule.cmdSelContact.Visible = False
    frmSchedule.Show 1
    If Not bOK Then
        Exit Sub
    End If
    
    lstDisplay.Clear
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
                       
        ' allocate a new record
        objDatabase.Activity.Add
                  
        ' set the TIME FIELDS (critical formatting required)
        strdate = frmSchedule.txtActivityMonth & "/" & frmSchedule.txtActivityDay & "/" & frmSchedule.txtActivityYear
               
        ' DATE/TIME FORMATTING IS VERY STRICT
        objDatabase.Activity.Data AF_StartTime, DateValue(strdate) & " " & frmSchedule.cboTime
        objDatabase.Activity.Data AF_Duration, frmSchedule.cboDuration
        strEndTime = EndTime()
        objDatabase.Activity.Data AF_EndTime, DateValue(strdate) & " " & strEndTime
      
        ' set the MISCELLANEOUS FIELDS
        objDatabase.Activity.Data AF_Regarding, frmSchedule.txtRegarding
        objDatabase.Activity.Data AF_BannerColor, RGB(0, 0, 255)
        
        'if the version of ACT is 5.0 or greater then Add details to the activity
        If Val(objDatabase.Version) > 4 Then
            objDatabase.Activity.Data AF_Details, frmAddDetail.txtDetail.Text
        End If
        ' set the priority
        If UCase(frmSchedule.cboPriority) = "LOW" Then
            objDatabase.Activity.Data AF_Priority, activitypriority_low
        End If
        If UCase(frmSchedule.cboPriority) = "MEDIUM" Then
            objDatabase.Activity.Data AF_Priority, activitypriority_medium
        End If
        If UCase(frmSchedule.cboPriority) = "HIGH" Then
            objDatabase.Activity.Data AF_Priority, activitypriority_high
        End If
        
        ' set the ACTIVITY TYPE
        If UCase(frmSchedule.cboActivitytype) = "CALL" Then
            objDatabase.Activity.Data AF_Type, activitytype_call
        End If
        If UCase(frmSchedule.cboActivitytype) = "MEETING" Then
            objDatabase.Activity.Data AF_Type, activitytype_meeting
        End If
        If UCase(frmSchedule.cboActivitytype) = "TODO" Then
            objDatabase.Activity.Data AF_Type, activitytype_todo
        End If
        
        'Set Private/Public
        If frmSchedule.chkPrivate Then
            objDatabase.Activity.Data AF_PublicPrivate, "2"
        Else
            objDatabase.Activity.Data AF_PublicPrivate, "1"
        End If
        
        'Set SendEmail
        If frmSchedule.chkSendEmail Then
            objDatabase.Activity.Data AF_EmailStatus, "1"
        Else
            objDatabase.Activity.Data AF_EmailStatus, "0"
        End If
        
        'Set the Alarm
        If frmSchedule.chkSetAlarm Then
            objDatabase.Activity.Data AF_AlarmStatus, "1"
            objDatabase.Activity.Data AF_LeadTime, frmSchedule.cboLeadtime
        Else
            objDatabase.Activity.Data AF_AlarmStatus, "0"
            objDatabase.Activity.Data AF_LeadTime, "0"
        End If
        lstDisplay.AddItem ""
        lstDisplay.AddItem "*** Activity Added!!!"
        lstDisplay.AddItem ""
        
        ' update the records contents (This has to be done)
        uniqueID = objDatabase.Activity.Update
        objDatabase.Activity.GoTo (uniqueID)
        
        'Check to see if the activity is Recurring and then if so make it recurring.
        If iRecurring = recurring_days Then
            objDatabase.Activity.SetRecurringDays frmRecurringDays.txtDays, frmRecurringDays.txtEndDate
        ElseIf iRecurring = recurring_weekdays Then
            lDayBits = idayBits(1) Or idayBits(2) Or idayBits(3) Or idayBits(4) Or idayBits(5) Or idayBits(6) Or idayBits(7)
            objDatabase.Activity.SetRecurringWeekDays frmRecurringWeek.txtFrequency, lDayBits, DateValue(frmRecurringWeek.txtEndDate.Text)
        ElseIf iRecurring = recurring_daysofmonth Then
            lWeekBits = iweekBits(1) Or iweekBits(2) Or iweekBits(3) Or iweekBits(4) Or iweekBits(5)
            lDayBits = idayBits(1) Or idayBits(2) Or idayBits(3) Or idayBits(4) Or idayBits(5) Or idayBits(6) Or idayBits(7)
            objDatabase.Activity.SetRecurringDaysAndWeeksofMonth frmRecurringMonth.txtFrequency.Text, lDayBits, lWeekBits, DateValue(frmRecurringMonth.txtEndDate.Text)
        End If
       
        'If there is an error check what the error is
        If objDatabase.Activity.Error Then
            MsgBox objDatabase.Activity.LastError
        End If
        
        ' make the association between a contact and a activity (very important).
        objDatabase.Activity.GoTo (uniqueID)
        objDatabase.Activity.FirstScheduledWith (frmSchedule.txtScheduledwith)
               
        'If there is an error check what the error is
        If objDatabase.Activity.Error Then
            MsgBox objDatabase.Activity.LastError
        End If
        
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub



Private Sub mnuUnclear_Click()
'This procedures Unclears all cleared activities
Dim objDatabase As Object
Dim objActivity As Object
Dim uniqueID As String

    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    Set objActivity = objDatabase.Activity
      
    If objDatabase.IsOpen Then
        objActivity.MoveFirst
        While Not objActivity.IsEOF
               If (objActivity.IsClear = True) Then
                    objActivity.UnClear
               End If
                         
            objActivity.MoveNext
        Wend
        lstDisplay.AddItem "UnCleared all Cleared activities. "
          Set objActivity = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
       
    End If
  ' clear the object
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
 
End Sub



