VERSION 5.00
Begin VB.Form frmBrowse 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Activity Records Browser"
   ClientHeight    =   4920
   ClientLeft      =   990
   ClientTop       =   2385
   ClientWidth     =   7095
   LinkTopic       =   "Form3"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4920
   ScaleWidth      =   7095
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdJump 
      Caption         =   "&Jump"
      Height          =   465
      Left            =   3780
      TabIndex        =   6
      Top             =   4275
      Width           =   870
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Height          =   420
      Left            =   5280
      TabIndex        =   5
      Top             =   4272
      Width           =   1500
   End
   Begin VB.CommandButton cmdPrevious 
      Caption         =   "&Previous"
      Height          =   465
      Left            =   1080
      TabIndex        =   2
      Top             =   4275
      Width           =   870
   End
   Begin VB.CommandButton cmdNext 
      Caption         =   "&Next"
      Height          =   465
      Left            =   1980
      TabIndex        =   3
      Top             =   4275
      Width           =   870
   End
   Begin VB.CommandButton cmdLast 
      Caption         =   "&Last"
      Height          =   465
      Left            =   2880
      TabIndex        =   4
      Top             =   4275
      Width           =   870
   End
   Begin VB.CommandButton cmdFirst 
      Caption         =   "&First"
      Height          =   465
      Left            =   180
      TabIndex        =   1
      Top             =   4275
      Width           =   870
   End
   Begin VB.ListBox lstDisplayRec 
      Height          =   3960
      ItemData        =   "Browser.frx":0000
      Left            =   240
      List            =   "Browser.frx":0002
      TabIndex        =   0
      Top             =   0
      Width           =   6615
   End
   Begin VB.Menu Contact 
      Caption         =   ""
   End
   Begin VB.Menu Activities 
      Caption         =   "&Activities"
      Begin VB.Menu SetTimelessFilter 
         Caption         =   "Set Timeless Filter"
      End
      Begin VB.Menu ClearTimelessFilter 
         Caption         =   "Clear Timeless Filter"
      End
      Begin VB.Menu sep1 
         Caption         =   "-"
      End
      Begin VB.Menu SetTypeFilter 
         Caption         =   "Set Type Filter (Filter out call-type activities)"
      End
      Begin VB.Menu ClearTypeFilter 
         Caption         =   "Clear Type Filter"
      End
      Begin VB.Menu sep2 
         Caption         =   "-"
      End
      Begin VB.Menu SetGroupFilter 
         Caption         =   "Set Group Filter"
      End
      Begin VB.Menu ClearGroupFilter 
         Caption         =   "Clear Group Filter"
      End
      Begin VB.Menu sep3 
         Caption         =   "-"
      End
      Begin VB.Menu SetContactFilter 
         Caption         =   "Set Contact Scope"
      End
      Begin VB.Menu ClearContactFilter2 
         Caption         =   "Clear Contact Scope"
      End
      Begin VB.Menu sep5 
         Caption         =   "-"
      End
      Begin VB.Menu SetPri2 
         Caption         =   "Filter out medium-priority activities"
      End
      Begin VB.Menu SetPriorityFilter 
         Caption         =   "Filter out low-priority activities"
      End
      Begin VB.Menu ClearPriorityFilter 
         Caption         =   "Clear Priority Filter"
      End
      Begin VB.Menu sep7 
         Caption         =   "-"
      End
      Begin VB.Menu SetDateFilter 
         Caption         =   "Set Date Scope (1/6/97-1/7/97)"
      End
      Begin VB.Menu ClearDateFilter 
         Caption         =   "Clear Date Scope"
      End
      Begin VB.Menu sep21 
         Caption         =   "-"
      End
      Begin VB.Menu SetClearedFilter 
         Caption         =   "Set Cleared Filter"
      End
      Begin VB.Menu ClearClearedFilter 
         Caption         =   "Clear Cleared Filter"
      End
   End
End
Attribute VB_Name = "frmBrowse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim objBrowseDatabase As Object


Sub display_record()
'Function to display a record
Dim lcounter As Integer
Dim length As Integer
Dim fid As Integer
Dim recordPos As Long

lstDisplayRec.Clear
If objBrowse.RecordCount > 0 Then
      recordPos = objBrowse.Position
      If Not recordPos = -1 Then
          lstDisplayRec.AddItem "Record:  " & objBrowse.Position & " of " & objBrowse.RecordCount
      Else
          lstDisplayRec.AddItem "Record: <UNKNOWN> / " & objBrowse.RecordCount
      End If
      lstDisplayRec.AddItem " "
      lstDisplayRec.AddItem "IsLocked=" & objBrowse.IsLocked
      lstDisplayRec.AddItem ""
   
          'First check the major version since we are going to use FieldIdAt which is available only in version 3.06 or later
      If objBrowseDatabase.MajorVersion = 1 Then  'ACTOLE.dll Version older than 3.06
        MsgBox "You have an ACTOLE.dll older than version 3.06." & Chr(13) & "Please Update !  "
        lstDisplayRec.AddItem "Activity Unique Id      :" & objBrowse.Data(AF_UniqueID)
        lstDisplayRec.AddItem "Activity Type           :" & objBrowse.Data(AF_Type)
        lstDisplayRec.AddItem "Activity Priority       :" & objBrowse.Data(AF_Priority)
        lstDisplayRec.AddItem "Activity Regarding      :" & objBrowse.Data(AF_Regarding)
        lstDisplayRec.AddItem "Activity StartTime      :" & objBrowse.Data(AF_StartTime)
        lstDisplayRec.AddItem "Activity EndTime        :" & objBrowse.Data(AF_EndTime)
        lstDisplayRec.AddItem "Activity Scheduled With :" & objBrowse.Data(AF_FirstScheduledWith)
        
      Else  'Version is 3.06 or later
          ' enumerate all fields in this record
          For lcounter = 1 To objBrowse.FIELDS.Count
              fid = objBrowse.FIELDS.FieldIdAt(lcounter)
              length = Len(objBrowse.Data(fid))
              If (length > 0) Then
                  lstDisplayRec.AddItem objBrowse.FIELDS.Label(fid) & " : " & objBrowse.Data(fid)
              End If
          Next
    End If
 Else
   lstDisplayRec.AddItem "No records found!!"
End If
    
End Sub

Private Sub ClearClearedFilter_Click()
'Claer the Cleared filter set earlier
    If objBrowseDatabase.IsOpen Then
        objBrowse.ClearClearedFilter
        display_record
        lstDisplayRec.SetFocus

    End If
End Sub

Private Sub ClearContactFilter2_Click()
'Clear Contact Scope set previously
    If objBrowseDatabase.IsOpen Then
        objBrowse.ClearContactScope
        display_record
        lstDisplayRec.SetFocus
    End If
End Sub



Private Sub ClearDateFilter_Click()

    If objBrowseDatabase.IsOpen Then
        objBrowse.ClearDateScope
        display_record
        lstDisplayRec.SetFocus
    End If
    
End Sub

Private Sub ClearGroupFilter_Click()
'Clear the group scope st previously
    If objBrowseDatabase.IsOpen Then
        objBrowse.ClearGroupScope
        display_record
        lstDisplayRec.SetFocus

    End If
End Sub










Private Sub ClearPriorityFilter_Click()
'Clear the Priority filters set earlier
    If objBrowseDatabase.IsOpen Then
        objBrowse.ClearPriorityFilter
        display_record
        lstDisplayRec.SetFocus
    End If
End Sub




Private Sub ClearTimelessFilter_Click()
'Clear the filter to display Timeless activities
 If objBrowseDatabase.IsOpen Then
        objBrowse.ClearTimelessFilter
        display_record
        lstDisplayRec.SetFocus
    End If
End Sub

Private Sub ClearTypeFilter_Click()
'Clear the type filter set previously
    If objBrowseDatabase.IsOpen Then
        objBrowse.ClearTypeFilter
        display_record
        lstDisplayRec.SetFocus

    End If
End Sub





Private Sub cmdClose_Click()
    Unload Me
End Sub


Private Sub cmdFirst_Click()
    'Displays the first record of the Activity table
    If objBrowseDatabase.IsOpen Then
        objBrowse.MoveFirst
        display_record
        lstDisplayRec.SetFocus
    End If

End Sub







Private Sub cmdJump_Click()
'Jumps to whichever record is selected of the Activity record
    bOK = False
    frmJump.Show 1
    If bOK Then
        objBrowse.Jump (frmJump.index.Text)
    End If
    display_record
    lstDisplayRec.SetFocus

End Sub








    


Private Sub Form_Load()
  '  Dim objBrowseDatabasebase As Object
    Dim objActivity As Object
    Dim lcounter As Long
        
    ' bring up the table chooser dialog
   
    ' clear the listbox
    lstDisplayRec.Clear
       
    ' create the object
    lstDisplayRec.AddItem "Creating Database Object"
    Set objBrowseDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplayRec.AddItem "Opening Database"
    objBrowseDatabase.Open dbName
    
     ' perform login validation routines
    Dim bReturn As Boolean
    bReturn = Login(objBrowseDatabase)
    If Not bReturn Then
        lstDisplayRec.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplayRec.AddItem "Database Open"
    lstDisplayRec.AddItem "Is Open: " & objBrowseDatabase.IsOpen
    
    ' assign the object
    
    Set objActivity = objBrowseDatabase.ACTIVITY
  
    If objBrowseDatabase.IsOpen Then
    
    objBrowseDatabase.PhoneFormatting = 1 ' set to canonical display
        
   ' objActivity.MoveFirst
    Set objBrowse = objBrowseDatabase.ACTIVITY
    objBrowse.MoveFirst
    display_record
        
    End If
                             
End Sub


Private Sub Form_Unload(Cancel As Integer)
    
    Set objBrowse = Nothing   ' release reference to table object
    objBrowseDatabase.Close
    
    Set objBrowseDatabase = Nothing
End Sub





Private Sub cmdLast_Click()
'Jump to Last record of the activity table
    If objBrowseDatabase.IsOpen Then
        objBrowse.MoveLast
        display_record
        lstDisplayRec.SetFocus
    End If
End Sub

Private Sub cmdNext_Click()
'List the next record of Activity table
    If objBrowseDatabase.IsOpen Then
        objBrowse.MoveNext
        If objBrowse.IsEOF Then
            MsgBox "End of Table"
        End If
        display_record
        lstDisplayRec.SetFocus
    End If
    
End Sub


Private Sub cmdPrevious_Click()
'List the previous record
    If objBrowseDatabase.IsOpen Then
        objBrowse.MovePrevious
        If objBrowse.IsBOF Then
            MsgBox "Beginning of Table"
        End If
        display_record
        lstDisplayRec.SetFocus
    End If
End Sub




Private Sub SetClearedFilter_Click()
'Filter out cleared activities
    If objBrowseDatabase.IsOpen Then
        objBrowse.SetClearedFilter
        display_record
        lstDisplayRec.SetFocus
    End If
End Sub

Private Sub SetContactFilter_Click()
'Set the Contact Scope
 Dim objContact As Object
 Dim strContact As String
 Dim uniqueID As String
    If objBrowseDatabase.IsOpen Then
        Set objContact = objBrowseDatabase.Contact
        strContact = InputBox("Enter Full Name of Contact", "Filter Contact")
        If strContact = "" Then
            Exit Sub
        End If
        objContact.Lookup CF_Name, strContact, 1
        
        'Get the unique Id of the Contact Found
        uniqueID = objContact.Data(CF_UniqueID)
        
        'Set the contact scope for the activities with the contact unique id
        objBrowse.SetContactScope (uniqueID)
        
        'Display all the activity records for that contact
        display_record
        lstDisplayRec.SetFocus

    End If
End Sub


Private Sub SetDateFilter_Click()
'Displays only the activities within the date range
Dim strStartDate As String
Dim strEndDate As String
  If objBrowseDatabase.IsOpen Then
        strStartDate = "6/1/97"
        strEndDate = "7/1/97"
        objBrowse.SetDateScope DateValue(strStartDate), DateValue(strEndDate)
        display_record
        lstDisplayRec.SetFocus
  End If
End Sub

Private Sub SetGroupFilter_Click()
'Set a group scope for the activities
Dim lcounter As Long
Dim groupUniqueID As String
    If objBrowseDatabase.IsOpen Then
      ' just get the uniqueID of the first group
      ' record and apply it to the group scope
      ' filter for the activity list.
     
       objBrowseDatabase.Group.MoveFirst
       groupUniqueID = objBrowseDatabase.Group.Data(GF_UniqueID)
    
       If groupUniqueID <> "" Then
         objBrowse.SetGroupScope (groupUniqueID)
       Else
         MsgBox "No groups Found"
       End If
       display_record
       lstDisplayRec.SetFocus

    End If
End Sub

Private Sub SetPri2_Click()
' filter out all low-priority activities
    If objBrowseDatabase.IsOpen Then
        objBrowse.SetPriorityFilter (activitypriority_medium)
        display_record
        lstDisplayRec.SetFocus

    End If
End Sub

Private Sub SetPriorityFilter_Click()
 ' filter out all low-priority activities
    If objBrowseDatabase.IsOpen Then
        objBrowse.SetPriorityFilter (activitypriority_low)
        display_record
        lstDisplayRec.SetFocus
    End If
End Sub


Private Sub SetTimelessFilter_Click()
'Set a  filter to display Timeless activities
 If objBrowseDatabase.IsOpen Then
        objBrowse.SetTimelessFilter
        display_record
        lstDisplayRec.SetFocus
 End If
End Sub


Private Sub SetTypeFilter_Click()
 ' filter out activities of type call
    If objBrowseDatabase.IsOpen Then
        objBrowse.SetTypeFilter (activitytype_call)
        display_record
        lstDisplayRec.SetFocus
    End If
End Sub


