VERSION 5.00
Begin VB.Form frmEmailMain 
   Caption         =   "EMAIL Object SampleProgram"
   ClientHeight    =   4920
   ClientLeft      =   450
   ClientTop       =   2085
   ClientWidth     =   7410
   Icon            =   "EmailMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4920
   ScaleWidth      =   7410
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add an Email "
      Height          =   375
      Left            =   2400
      TabIndex        =   7
      Top             =   3960
      Width           =   2055
   End
   Begin VB.CommandButton lstFieldSchema 
      Caption         =   "List Field Schema"
      Height          =   372
      Left            =   120
      TabIndex        =   6
      Top             =   3960
      Width           =   2052
   End
   Begin VB.CommandButton cmdReload 
      Caption         =   "ReLoad database"
      Height          =   372
      Left            =   5400
      TabIndex        =   5
      Top             =   240
      Width           =   1860
   End
   Begin VB.CommandButton cmdListEmail 
      Caption         =   "List Email Addresses"
      Height          =   372
      Left            =   4680
      TabIndex        =   4
      Top             =   3960
      Width           =   2052
   End
   Begin VB.Frame Frame1 
      Caption         =   "ACT Database"
      Height          =   876
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Width           =   5172
      Begin VB.TextBox txtDBName 
         Height          =   372
         Left            =   135
         TabIndex        =   1
         Top             =   360
         Width           =   4920
      End
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Exit"
      Height          =   372
      Left            =   5280
      TabIndex        =   3
      Top             =   4440
      Width           =   1860
   End
   Begin VB.ListBox lstDisplay 
      Height          =   2595
      ItemData        =   "EmailMain.frx":0442
      Left            =   120
      List            =   "EmailMain.frx":0444
      TabIndex        =   0
      Top             =   960
      Width           =   7080
   End
   Begin VB.Line Line1 
      BorderWidth     =   2
      X1              =   7185
      X2              =   120
      Y1              =   3840
      Y2              =   3840
   End
End
Attribute VB_Name = "frmEmailMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit












Private Sub cmdAdd_Click()
'List the email address and other email Properties for a Contact
Dim objDatabase As Object
Dim lcounter As Long
Dim objEmail As Object
Dim strContactID As String
Dim strEmailID As String
Dim iposition As Integer
Dim strUniqueID As String
  
    ' bring up the contact chooser
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        MsgBox "No Contact Selected"
        Exit Sub ' return without doing anything
    End If
    
    iposition = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    strContactID = Left$(frmContactPicker.lstPicker.Text, iposition - 1)
   
    bOK = False
    frmAddEmail.Show 1
    
    'If user exits from the add new Email dialog
    'with insufficient information then exit this sub now.
    If Not bOK Then
        MsgBox " Information entered in insufficient to add an Email!"
        Exit Sub
    End If
    
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the EMAIL table object
    Set objEmail = objDatabase.EMAIL
    
    If objDatabase.IsOpen Then
        objEmail.MoveFirst
        objEmail.Add
                           
        ' set field data
        objEmail.Data EF_Logon, frmAddEmail.txtLogon.Text
        objEmail.Data EF_Carrier, frmAddEmail.cboCarrier.Text
        'Check if the email address should be primary and set accordingly
        If frmAddEmail.chkPrimary.Value = 1 Then
            objEmail.Data EF_PrimaryStatus, 1
        Else
            objEmail.Data EF_PrimaryStatus, 0
        End If
        objEmail.Data EF_ContactId, strContactID
        strEmailID = objEmail.Update
        objEmail.GoTo strEmailID
        
        lstDisplay.AddItem "New Email has been added!"
        
        Set objEmail = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    lstDisplay.SetFocus
        
End Sub

Private Sub cmdListEmail_Click()
'List the email address and other email Properties for a Contact
Dim objDatabase As Object
Dim lcounter As Long
Dim objEmail As Object
Dim strContactID As String
Dim iposition As Integer
Dim strUniqueID As String
  
    ' bring up the contact chooser
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        MsgBox "No Contact Selected"
        Exit Sub ' return without doing anything
    End If
    
    iposition = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    strContactID = Left$(frmContactPicker.lstPicker.Text, iposition - 1)
   
    
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    
    Set objEmail = objDatabase.EMAIL
    
    If objDatabase.IsOpen Then
        ' enumerate all of the records in the contact table
        objEmail.MoveFirst
        'Only have the records for EmailRecords of strContactId
        objEmail.SetContactScope strContactID
        While Not objEmail.IsEOF
                    
                lstDisplay.AddItem "Email Create Time Stamp: " & objEmail.Data(EF_CreateTimestamp)
                lstDisplay.AddItem "Email Edit Time Stamp: " & objEmail.Data(EF_EditTimestamp)
                lstDisplay.AddItem "Email Merge Time Stamp: " & objEmail.Data(EF_MergeTimestamp)
                lstDisplay.AddItem "Email Logon: " & objEmail.Data(EF_Logon)
                lstDisplay.AddItem "Email Carrier: " & objEmail.Data(EF_Carrier)
                lstDisplay.AddItem "Email Primary: " & objEmail.Data(EF_PrimaryStatus)
               
                lstDisplay.AddItem " "
                objEmail.MoveNext
        Wend
                         
        Set objEmail = Nothing
        
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
    
End Sub




Private Sub cmdReload_Click()
'This function reloads the database if
     'the database is changed by the user
     
    dbName = txtDBName.Text
    MsgBox "The database has changed"
    
    'The Contact Picker form needs to be reloaded
    
   Unload frmContactPicker
   frmContactPicker.Hide
End Sub

Private Sub cmdExit_Click()
    End
End Sub

















       








Private Sub Form_Load()
  dbName = "C:\PROGRAM FILES\ACT\DATABASE\ACT5DEMO.DBF"
  txtDBName.Text = dbName
  
  bAlreadyLoggedIn = False
    
   With Screen
     Left = (.Width - Width) / 2
     Top = (.Height - Height) / 2
   End With
 
End Sub










































Private Sub lstFieldSchema_Click()
'This function lists the field schema for all the fields
'in the Email Object.

 Dim objDatabase As Object
 Dim objEmail As Object
 Dim lcounter As Long
 Dim strOut As String
 Dim iFieldId As Integer
 
    lstDisplay.Clear
    lstDisplay.AddItem "*** Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
                
    lstDisplay.AddItem "*** Opening Database"
    objDatabase.Open dbName
    lstDisplay.AddItem "*** Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
                
    ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    'Check if version of the ACTOLE.dll is  3.0.6 or greater (3.0.5 returns a 1 )
    If objDatabase.MajorVersion = 1 Then
       MsgBox "You have an ACTOLE.dll older than version 3.0.6." & Chr(13) & "This function needs the new features. Please Update and Retry!  "
       lstDisplay.Clear
       objDatabase.Close
       Exit Sub
    End If
                
    If objDatabase.IsOpen Then
                
    ' assign the object
        Set objEmail = objDatabase.EMAIL
        
        lstDisplay.AddItem "Name: " & objDatabase.Name
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Record count: " & objEmail.recordCount
        lstDisplay.AddItem "Field Count : " & objEmail.FieldCount
        lstDisplay.AddItem "Table Name : " & objEmail.Name
        lstDisplay.AddItem ""
    
        For lcounter = 0 To objEmail.FIELDS.Count()
            'List all properties for each field
            strOut = ""
                                            
            If (objEmail.FIELDS.FieldIdAt(lcounter) <> -1) Then
                iFieldId = objEmail.FIELDS.FieldIdAt(lcounter)
                strOut = strOut + "* Field " & ": " & " FIELD ID=" & objEmail.FIELDS.FieldIdAt(lcounter)
                strOut = strOut + " " & "Label=" & objEmail.FIELDS.Label(iFieldId)
                strOut = strOut + ", Type: " & objEmail.FIELDS.Type(iFieldId)
                strOut = strOut + ", Length: " & objEmail.FIELDS.length(iFieldId)
                         
                lstDisplay.AddItem strOut
                strOut = ""
                strOut = strOut + "   Indexed:" & objEmail.FIELDS.IsIndexed(iFieldId)
                strOut = strOut + ", Initial Value:" & objEmail.FIELDS.InitialValue(iFieldId)
                strOut = strOut + ", Sortable:" & objEmail.FIELDS.IsSortable(iFieldId)
                strOut = strOut + ", Modifiable:" & objEmail.FIELDS.Modifiable(iFieldId)
                strOut = strOut + ", PopupList:" & objEmail.FIELDS.HasPopupList(iFieldId)
                lstDisplay.AddItem strOut
                         
                strOut = ""
                strOut = strOut + "   EntryTrigger=" & objEmail.FIELDS.EntryTrigger(iFieldId)
                strOut = strOut + ", ExitTrigger=" & objEmail.FIELDS.ExitTrigger(iFieldId)
                lstDisplay.AddItem strOut
                lstDisplay.AddItem ""
                         
            End If
        Next
                                     
        Set objEmail = Nothing
                 
        lstDisplay.AddItem "*** Closing Database"
        objDatabase.Close
                 
        lstDisplay.AddItem "*** Database Closed"
    End If
                
    Set objDatabase = Nothing
                
    lstDisplay.SetFocus
End Sub


