Attribute VB_Name = "Module2"

' NOTE this is a constant used throughout the app to for displaying fields.  If you
' would like to view user-defined fields set this value higher.  User-Defined fields
' in ACT start numbering at 1000.  I have set this intentionally at a lower number
' for speed purposes.
Public Const MAX_FIELDID = 98


' Contact Field Unique IDs
Public Const CF_UniqueID = 1
Public Const CF_CreateTimestamp = 2
Public Const CF_EditTimestamp = 3
Public Const CF_MergeTimestamp = 4
Public Const CF_PublicPrivate = 5
Public Const CF_RecordManager = 6
Public Const CF_Company = 25
Public Const CF_Name = 26
Public Const CF_Address1 = 27
Public Const CF_Address2 = 28
Public Const CF_Address3 = 29
Public Const CF_City = 30
Public Const CF_State = 31
Public Const CF_Zip = 32
Public Const CF_Country = 33
Public Const CF_IDStatus = 34
Public Const CF_Phone = 35
Public Const CF_Fax = 36
Public Const CF_HomePhone = 37
Public Const CF_MobilePhone = 38
Public Const CF_Pager = 39
Public Const CF_Salutation = 40
Public Const CF_LastMeet = 41
Public Const CF_LastReach = 42
Public Const CF_LastAttempt = 43
Public Const CF_LetterDate = 44
Public Const CF_Unused1 = 45
Public Const CF_Title = 46
Public Const CF_Assistant = 47
Public Const CF_LastResults = 48
Public Const CF_ReferredBy = 49
Public Const CF_User1 = 50
Public Const CF_User2 = 51
Public Const CF_User3 = 52
Public Const CF_User4 = 53
Public Const CF_User5 = 54
Public Const CF_User6 = 55
Public Const CF_User7 = 56
Public Const CF_User8 = 57
Public Const CF_User9 = 58
Public Const CF_User10 = 59
Public Const CF_User11 = 60
Public Const CF_User12 = 61
Public Const CF_User13 = 62
Public Const CF_User14 = 63
Public Const CF_User15 = 64
Public Const CF_AltAddress1 = 65
Public Const CF_AltAddress2 = 66
Public Const CF_AltCity = 67
Public Const CF_AltState = 68
Public Const CF_AltZip = 69
Public Const CF_AltCountry = 70
Public Const CF_AltPhone = 71
Public Const CF_Name2 = 72
Public Const CF_Title2 = 73
Public Const CF_Phone2 = 74
Public Const CF_Name3 = 75
Public Const CF_Title3 = 76
Public Const CF_Phone3 = 77
Public Const CF_FirstName = 78
Public Const CF_LastName = 79
Public Const CF_Ext = 80                   ' the work phone extension
Public Const CF_FaxExt = 81                ' the fax extension
Public Const CF_AltPhoneExt = 82           ' alternate phone extension
Public Const CF_Phone2Ext = 83             ' contact 2 phone extension
Public Const CF_Phone3Ext = 84             ' contact 3 phone extension
Public Const CF_AsstTitle = 85             ' the assistants title
Public Const CF_AsstPhone = 86             ' the assistant phone
Public Const CF_AsstExt = 87               ' the assistant extension
Public Const CF_Department = 88            ' the contact's department
Public Const CF_Spouse = 89                ' the contact's spouse name
Public Const CF_Creator = 90               ' the creator of the record
Public Const CF_UsersCompany = 91          ' equivalent to the ACT! 2.0 Owner field (the company of the user that owns the record)
Public Const CF_Alt1Reach = 92             ' alternate contact 1 last reach (for ACT! 2.0 compatability)
Public Const CF_Alt2Reach = 93             ' alternate contact 2 last reach (for ACT! 2.0 compatability)
Public Const CF_URL = 94                   ' URL or web site address
Public Const CF_TickerSymbol = 95
Public Const CF_ContactType = 125
Public Const CVF_EmailAddress = 200        ' for display of e-mail address
Public Const CVF_Note = 201                ' for "import" of note
Public Const CVF_EmailLogon = 202          ' separate components for e-mail logon
Public Const CVF_EmailCarrier = 203        ' separate component for e-mail carrier


' Group Field Unique IDs
Public Const GF_UniqueID = 1
Public Const GF_CreateTimestamp = 2
Public Const GF_EditTimestamp = 3
Public Const GF_MergeTimestamp = 4
Public Const GF_PublicPrivate = 5
Public Const GF_RecordManager = 6
Public Const GF_Name = 25
Public Const GF_Division = 26
Public Const GF_Address1 = 27
Public Const GF_Address2 = 28
Public Const GF_Address3 = 29
Public Const GF_City = 30
Public Const GF_State = 31
Public Const GF_Zip = 32
Public Const GF_Country = 33
Public Const GF_Priority = 35
Public Const GF_User1 = 36
Public Const GF_User2 = 37
Public Const GF_User3 = 38
Public Const GF_User4 = 39
Public Const GF_Description = 40
Public Const GF_User5 = 47
Public Const GF_User6 = 48      ' extra user field
Public Const GF_Creator = 54    ' the creator of the record
Public Const GF_ParentId = 55
Public Const GF_GroupLevel = 56
Public Const GF_Region = 57
Public Const GF_Industry = 58
Public Const GF_SicCode = 59
Public Const GF_Employees = 60
Public Const GF_Revenue = 61
Public Const GF_TotalInGroup = 100
Public Const GVF_Note = 200


' Activity Field Unique IDs
Public Const AF_UniqueID = 1
Public Const AF_CreateTimestamp = 2
Public Const AF_EditTimestamp = 3
Public Const AF_MergeTimestamp = 4
Public Const AF_PublicPrivate = 5
Public Const AF_Type = 25
Public Const AF_Priority = 26
Public Const AF_Regarding = 27
Public Const AF_StartTime = 28       ' the starting time of the series of activities
Public Const AF_EndTime = 29         ' the ending time of the series of activities
Public Const AF_Duration = 30        ' the duration of a single instance of the activity
Public Const AF_TimelessStatus = 31
Public Const AF_LeadTime = 32
Public Const AF_AlarmStatus = 33
Public Const AF_BannerColor = 34
Public Const AF_EmailStatus = 35
Public Const AF_Recurring = 36
Public Const AF_ScheduledFor = 37
Public Const AF_ScheduledBy = 38
Public Const AF_GroupId = 39
Public Const AF_FirstScheduledWith = 40   ' the first scheduled with (for performance purposes)
Public Const AF_ClearedStatus = 41        ' the cleared status of this activity
Public Const AF_RecurringId = 42          ' unique id of this recurring chain
Public Const AF_Exceptions = 43           ' recurring exception list (stored as a blob)
Public Const AF_ExceptionDate = 44
Public Const AF_Details = 45
Public Const AF_TotalInActivity = 100
Public Const AF_TotalDuration = 101       ' total duration of the activity series in minutes
Public Const AVF_ScheduledDate = 200
Public Const AVF_ScheduledTime = 201



' Note/History Field Unique IDs
Public Const NHF_UniqueID = 1
Public Const NHF_CreateTimestamp = 2
Public Const NHF_EditTimestamp = 3
Public Const NHF_MergeTimestamp = 4
Public Const NHF_Type = 25
Public Const NHF_Text = 26
Public Const NHF_UserTime = 27
Public Const NHF_Attachment = 28
Public Const NHF_ContactId = 29
Public Const NHF_GroupId = 30
Public Const NHF_ActivityId = 31
Public Const NHVF_RecordedDate = 200
Public Const NHVF_RecordedTime = 201


' EMAIL Field Unique IDs
Public Const EF_UniqueID = 1
Public Const EF_CreateTimestamp = 2
Public Const EF_EditTimestamp = 3
Public Const EF_MergeTimestamp = 4
Public Const EF_Logon = 25
Public Const EF_Carrier = 26
Public Const EF_PrimaryStatus = 27
Public Const EF_ContactId = 28

' SALES Field Unique IDs  ' New for ACT!2000
Public Const SLF_UniqueID = 1
Public Const SLF_CreateTimestamp = 2
Public Const SLF_EditTimestamp = 3
Public Const SLF_MergeTimestamp = 4
Public Const SLF_ContactId = 25
Public Const SLF_GroupId = 26
Public Const SLF_Status = 27
Public Const SLF_ProductId = 28
Public Const SLF_TypeId = 29
Public Const SLF_Probability = 30
Public Const SLF_SaleDate = 31
Public Const SLF_Units = 32
Public Const SLF_UnitPrice = 33
Public Const SLF_Amount = 34
Public Const SLF_SaleStartDate = 35
Public Const SLF_Notes = 36
Public Const SLF_CompetitorsId = 37
Public Const SLF_Reason = 38
Public Const SLF_SalesStage = 39
Public Const SLVF_ProductName = 200


' LIST Table Unique IDs  ' New for ACT!2000
Public Const LTF_UniqueID = 1
Public Const LTF_Type = 25
Public Const LTF_Name = 26

' activity types
Public Const activitytype_call = 0
Public Const activitytype_meeting = 1
Public Const activitytype_todo = 2

' activity priorities
Public Const activitypriority_high = 0
Public Const activitypriority_medium = 1
Public Const activitypriority_low = 2

' history types
Public Const history_callattempt = 0
Public Const history_callcomplete = 1
Public Const history_callreceived = 2
Public Const history_lettersent = 5
Public Const history_meetingdone = 6
Public Const history_meetingnotdone = 7
Public Const history_tododone = 8
Public Const history_todonotdone = 9
Public Const history_timer = 10
Public Const history_callerased = 11
Public Const history_deletedcontact = 12
Public Const history_updatecontact = 13
Public Const history_updateconact = 14
Public Const history_updatedelact = 15
Public Const history_msgemailsent = 16
Public Const history_callleftmessage = 17
Public Const history_faxsent = 18
Public Const history_syncsent = 19
Public Const history_syncreceived = 20
Public Const history_replacefieldslog = 21
Public Const history_todoerased = 22
Public Const history_meetingerased = 23
Public Const history_error = 24

' days in month definitions (recurring activities)
Public Const day_sunday = 1
Public Const day_monday = 2
Public Const day_tuesday = 4
Public Const day_wednesday = 8
Public Const day_thursday = 16
Public Const day_friday = 32
Public Const day_saturday = 64

' weeks in the month definitions (recurring activities)
Public Const week_one = 1
Public Const week_two = 2
Public Const week_three = 4
Public Const week_four = 8
Public Const week_last = 16

' types of recurring activities
Public Const recurring_none = 0
Public Const recurring_days = 1
Public Const recurring_weekdays = 2
Public Const recurring_daysofmonth = 3
Public Const recurring_daysandweeksofmonth = 4

' tables
Public Const TABLE_CONTACT = 1
Public Const TABLE_ACTIVITY = 2
Public Const TABLE_NOTEHISTORY = 4
Public Const TABLE_EMAILADDRESS = 8
Public Const TABLE_GROUP = 16
Public Const TABLE_SALES = 32

' sales status
Public Const SALESSTATUS_OPEN = 0
Public Const SALESSTATUS_WON = 1
Public Const SALESSTATUS_LOST = 2

' day positions in the month
Public Const MONTHDAYS_1 = 1
Public Const MONTHDAYS_2 = 2
Public Const MONTHDAYS_3 = 4
Public Const MONTHDAYS_4 = 8
Public Const MONTHDAYS_5 = 16
Public Const MONTHDAYS_6 = 32
Public Const MONTHDAYS_7 = 64
Public Const MONTHDAYS_8 = 128
Public Const MONTHDAYS_9 = 256
Public Const MONTHDAYS_10 = 512
Public Const MONTHDAYS_11 = 1024
Public Const MONTHDAYS_12 = 2048
Public Const MONTHDAYS_13 = 4096
Public Const MONTHDAYS_14 = 8192
Public Const MONTHDAYS_15 = 16384
Public Const MONTHDAYS_16 = 32768
Public Const MONTHDAYS_17 = 65536
Public Const MONTHDAYS_18 = 131072
Public Const MONTHDAYS_19 = 262144
Public Const MONTHDAYS_20 = 524288
Public Const MONTHDAYS_21 = 1048576
Public Const MONTHDAYS_22 = 2097152
Public Const MONTHDAYS_23 = 4194304
Public Const MONTHDAYS_24 = 8388608
Public Const MONTHDAYS_25 = 16777216
Public Const MONTHDAYS_26 = 33554432
Public Const MONTHDAYS_27 = 67108864
Public Const MONTHDAYS_28 = 134217728
Public Const MONTHDAYS_29 = 268435456
Public Const MONTHDAYS_30 = 536870912
Public Const MONTHDAYS_31 = 1073741824


