VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Users Sample"
   ClientHeight    =   3780
   ClientLeft      =   1155
   ClientTop       =   2175
   ClientWidth     =   5775
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3780
   ScaleWidth      =   5775
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   372
      Left            =   3960
      TabIndex        =   6
      Top             =   3240
      Width           =   1332
   End
   Begin VB.CommandButton cmdUserInfo 
      Caption         =   "List User Information"
      Height          =   372
      Left            =   2040
      TabIndex        =   5
      Top             =   3240
      Width           =   1572
   End
   Begin VB.Frame Frame2 
      Caption         =   "Database Name"
      Height          =   612
      Left            =   240
      TabIndex        =   3
      Top             =   120
      Width           =   5052
      Begin VB.TextBox txtdbName 
         Height          =   288
         Left            =   120
         TabIndex        =   4
         Text            =   "c:\Program Files\ACT\Database\Act5demo.dbf"
         Top             =   240
         Width           =   4812
      End
   End
   Begin VB.Frame Frame1 
      Height          =   2052
      Left            =   240
      TabIndex        =   1
      Top             =   840
      Width           =   5052
      Begin VB.ListBox lstDisplay 
         Height          =   1230
         ItemData        =   "Users.frx":0000
         Left            =   120
         List            =   "Users.frx":0002
         TabIndex        =   2
         Top             =   360
         Width           =   4812
      End
   End
   Begin VB.CommandButton cmdAddUser 
      Caption         =   "Add a User"
      Height          =   372
      Left            =   240
      TabIndex        =   0
      Top             =   3240
      Width           =   1452
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cmdAddUser_Click()
'This function adds a User and then assigns
'an existing Contact as the My Record for that User

Dim objDatabase As Object
Dim sVersion As String
Dim objUsers As Object
Dim objContact As Object
Dim sName As String
Dim sPassword As String
Dim nSecurity As Integer
Dim bR As Boolean
Dim iPosition As Integer
Dim sContactId As String

Set objDatabase = CreateObject("Actole.Database")
If Val(objDatabase.Version) < 4 Then
    MsgBox "You need at least ACT 4.0 to execute this"
    Exit Sub
End If
dbName = txtdbName.Text
objDatabase.Open dbName

Dim bReturn As Boolean
bReturn = Login(objDatabase)
If Not bReturn Then
    lstDisplay.AddItem "Failed user validation process!!!"
End If

If objDatabase.IsOpen = True Then
    lstDisplay.AddItem objDatabase.Name & "  is Open"
   
    Set objUsers = objDatabase.Users
    
    'Only Users with Administrator priveledges is allowed to AddUser
    If objUsers.CurrentUserSecurity <> 5 Then  'Not an administrator
        MsgBox "You should have an Administrator Security level  to Add a User"
        Set objUsers = Nothing
        objDatabase.Close
        Set objDatabase = Nothing
        Exit Sub
    End If
    
    frmAddUser.Show 1
    
    sName = frmAddUser.txtName
    If sName = "" Then
        MsgBox "No User Name Entered"
        Set objUsers = Nothing
        objDatabase.Close
        Set objDatabase = Nothing
        Exit Sub
    End If
    sPassword = frmAddUser.txtPassword
    If frmAddUser.cboSecurity.ListIndex = 0 Then nSecurity = 1  'Browse User
    If frmAddUser.cboSecurity.ListIndex = 1 Then nSecurity = 3  'Standard
    If frmAddUser.cboSecurity.ListIndex = 2 Then nSecurity = 5  'Administrator
    
    'Adding the User with sName as Name ,sPassword as Password and nSecurity as Security
    bR = objUsers.AddUser(sName, sPassword, nSecurity)  'Returns true on success and False on failure
    If bR <> True Then
        lstDisplay.AddItem "Error adding User , Verify that the database is locked "
        Exit Sub
    End If
    lstDisplay.AddItem "Setting the MyRecord for " & sName
    
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        MsgBox "No Contact Selected"
        Exit Sub ' return without doing anything
    End If
    Set objContact = objDatabase.Contact
    'Get the Contacts Unique ID
    iPosition = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    sContactId = Left$(frmContactPicker.lstPicker.Text, iPosition - 1)
    
    objContact.GoTo sContactId
    'Setting the My Record for the User sName with the Current Contact
    objContact.SetAsMyRecord (sName)
    
    lstDisplay.AddItem objContact.Data(CF_Name) & " is the MyRecord for " & sName
    
    'Releasing all objects
    Set objContact = Nothing
    Set objUsers = Nothing
    objDatabase.Close
    
Else
    lstDisplay.AddItem "Error opening a database"
End If
    Set objDatabase = Nothing

End Sub


Private Sub cmdCancel_Click()
    End
End Sub


Private Sub cmdUserInfo_Click()
    Dim objDatabase As Object
    Dim objUser As Object
    Dim iUserCount As Integer
    Dim i As Integer
     
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    dbName = txtdbName.Text
    objDatabase.Open dbName
    
    If Val(objDatabase.Version) < 4 Then
        MsgBox "You need at least ACT 4.0 to execute this"
        Exit Sub
    End If
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    'Set the objects
    Set objUser = objDatabase.Users
    
    i = 1
    If objDatabase.IsOpen Then
        iUserCount = objUser.Count
        While i <= iUserCount
            lstDisplay.AddItem objUser.Name(i)
            lstDisplay.AddItem " Password: " & objUser.GetPassword(i) & " Security: " & objUser.Security(i) & " Access :" & objUser.Access(i)
            lstDisplay.AddItem ""
            i = i + 1
        Wend
        
         Set objUser = Nothing
         lstDisplay.AddItem " "
         lstDisplay.AddItem "Closing Database"
         objDatabase.Close
         lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
    
End Sub


Private Sub Form_Load()
dbName = txtdbName.Text
End Sub


Private Sub txtdbName_Change()
dbName = txtdbName.Text
End Sub


