// VCNewGluDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCNewGlu.h"
#include "VCNewGluDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCNewGluDlg dialog

CVCNewGluDlg::CVCNewGluDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCNewGluDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCNewGluDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVCNewGluDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCNewGluDlg)
	DDX_Control(pDX, IDC_EVENTLIST, m_ListBox);
	DDX_Control(pDX, IDC_ACTEVENTCTRL1, m_ActEvent);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCNewGluDlg, CDialog)
	//{{AFX_MSG_MAP(CVCNewGluDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_STARTREPORTING, OnStartreporting)
	ON_BN_CLICKED(IDC_STOPREPORTING, OnStopreporting)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCNewGluDlg message handlers

BOOL CVCNewGluDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVCNewGluDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCNewGluDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCNewGluDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCNewGluDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCNewGluDlg)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 1 /* OnDatabaseOpen */, OnDatabaseOpen, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 2 /* OnDatabaseClose */, OnDatabaseClose, VTS_NONE)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 3 /* OnContactChange */, OnContactChange, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 4 /* OnContactAdd */, OnContactAdd, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 5 /* OnContactDelete */, OnContactDelete, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 6 /* OnContactPosChange */, OnContactPosChange, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 7 /* OnContactListChange */, OnContactListChange, VTS_I4)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 8 /* OnGroupChange */, OnGroupChange, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 9 /* OnGroupAdd */, OnGroupAdd, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 10 /* OnGroupDelete */, OnGroupDelete, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 11 /* OnGroupPosChange */, OnGroupPosChange, VTS_BSTR)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 12 /* OnGroupListChange */, OnGroupListChange, VTS_I4)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 13 /* OnContactLookupChange */, OnContactLookupChange, VTS_NONE)
	ON_EVENT(CVCNewGluDlg, IDC_ACTEVENTCTRL1, 14 /* OnActUserWantsToClose */, OnActUserWantsToClose, VTS_BOOL)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CVCNewGluDlg::OnDatabaseOpen(LPCTSTR lpszDBName) 
{
	// Database is Open (Name of the Database is lpszDBName)
	CString szOut =lpszDBName;
	szOut += " --- Database Open ";
	m_ListBox.AddString(szOut);
}

void CVCNewGluDlg::OnDatabaseClose() 
{
	//Database has closed
	m_ListBox.AddString("Database closed");
}

void CVCNewGluDlg::OnContactChange(LPCTSTR lpszUniqueID) 
{
	// The Contact Information has been changed for Contact with uniqueId lpszUniqueID
	
	CString szOut =lpszUniqueID;
	szOut += "--- Contact Information has changed .";
	m_ListBox.AddString(szOut);
}

void CVCNewGluDlg::OnContactAdd(LPCTSTR lpszUniqueID) 
{
	// If lpszUniqueID is not blank a new Contact has been Added
	
		CString szOut =lpszUniqueID;
		if (szOut != "")
	{
		szOut += "--- Contact Added .";
		m_ListBox.AddString(szOut);
	}
}

void CVCNewGluDlg::OnContactDelete(LPCTSTR lpszUniqueID) 
{
		// Contact Deleted
	CString szOut =lpszUniqueID;
	szOut += "--- Contact deleted.";
	m_ListBox.AddString(szOut);
}

void CVCNewGluDlg::OnContactPosChange(LPCTSTR lpszUniqueID) 
{
		// Contact Position Changed
	CString szOut =lpszUniqueID;
	szOut += "--- Contact Position has Changed.";
	m_ListBox.AddString(szOut);
}

void CVCNewGluDlg::OnContactListChange(long nCount) 
{
	// Contact List Changed - New Contact Count is nCount
	char szCount[25] ;
	itoa (nCount, szCount ,10) ;
	CString szOut = "New Count for the Contact List :" ;
	szOut += szCount;
	m_ListBox.AddString(szOut);
	
}

void CVCNewGluDlg::OnGroupChange(LPCTSTR lpszUniqueID) 
{
	// Group Information has Changed
	CString szOut =lpszUniqueID;
	szOut += "--- Group Information has Changed.";
	m_ListBox.AddString(szOut);
	
}

void CVCNewGluDlg::OnGroupAdd(LPCTSTR lpszUniqueID) 
{
	CString szOut =lpszUniqueID;
	// If lpszUniqueID is not blank a new Group has been Added
	if (szOut != "")
	{
		szOut += "--- New Group Added";
		m_ListBox.AddString(szOut);
	}
	
}

void CVCNewGluDlg::OnGroupDelete(LPCTSTR lpszUniqueID) 
{
	// Group Deleted
	CString szOut =lpszUniqueID;
	szOut += "--- Group Deleted";
	m_ListBox.AddString(szOut);
}

void CVCNewGluDlg::OnGroupPosChange(LPCTSTR lpszUniqueID) 
{
	// Group Deleted
	CString szOut =lpszUniqueID;
	szOut += "--- is the Current Group";
	m_ListBox.AddString(szOut);
}

void CVCNewGluDlg::OnGroupListChange(long nCount) 
{
 // Group List Changed - New Group Count is nCount
	char szCount[25] ;
	itoa (nCount, szCount ,10) ;
	CString szOut = "New Count for the Group List :" ;
	szOut += szCount;
	m_ListBox.AddString(szOut);
}

void CVCNewGluDlg::OnContactLookupChange() 
{
	//The Contact Lookup has changed
	m_ListBox.AddString("Lookup has Changed");
}

void CVCNewGluDlg::OnActUserWantsToClose(BOOL bIsFinal) 
{
	//The User is closing ACT!
		m_ListBox.AddString("The User Wants to Close!");
		m_ActEvent.UnRegister() ;
}

void CVCNewGluDlg::OnStartreporting() 
{
	long ret ;
	ret = m_ActEvent.Register(0) ;
	if ( ret < 1 )  //Some Problem registering
	{
		if (!m_ActEvent.IsActRunning())  //Check if ACT is running
		{
			AfxMessageBox ("ACT is not running , Please Start Act and then Select the button again!");
		}
		else if (ret == -1)   //Multiple registration is not allowed
		{
			AfxMessageBox ("You have already registered once!");
		}
		else   //Some other problem
		{
			AfxMessageBox ("There is Problem registering the Control !");
		}
	}
}

void CVCNewGluDlg::OnStopreporting() 
{
	m_ActEvent.UnRegister();
}

void CVCNewGluDlg::OnClose() 
{
	m_ActEvent.UnRegister();	
	CDialog::OnClose();
	
}
