// VCNewGluDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVCNewGluDlg dialog
//{{AFX_INCLUDES()
#include "actevent.h"
//}}AFX_INCLUDES

class CVCNewGluDlg : public CDialog
{
// Construction
public:
	CVCNewGluDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CVCNewGluDlg)
	enum { IDD = IDD_EVENTREPORTER };
	CListBox	m_ListBox;
	CActEvent	m_ActEvent;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVCNewGluDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CVCNewGluDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDatabaseOpen(LPCTSTR lpszDBName);
	afx_msg void OnDatabaseClose();
	afx_msg void OnContactChange(LPCTSTR lpszUniqueID);
	afx_msg void OnContactAdd(LPCTSTR lpszUniqueID);
	afx_msg void OnContactDelete(LPCTSTR lpszUniqueID);
	afx_msg void OnContactPosChange(LPCTSTR lpszUniqueID);
	afx_msg void OnContactListChange(long nCount);
	afx_msg void OnGroupChange(LPCTSTR lpszUniqueID);
	afx_msg void OnGroupAdd(LPCTSTR lpszUniqueID);
	afx_msg void OnGroupDelete(LPCTSTR lpszUniqueID);
	afx_msg void OnGroupPosChange(LPCTSTR lpszUniqueID);
	afx_msg void OnGroupListChange(long nCount);
	afx_msg void OnContactLookupChange();
	afx_msg void OnActUserWantsToClose(BOOL bIsFinal);
	afx_msg void OnStartreporting();
	afx_msg void OnStopreporting();
	afx_msg void OnClose();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
