    'This script finds all the Contacts without an email address.
    'Firstly we Create a Group NoEmail and then 
    'each contact without an email address is added to this group.
    
    'Create a Views object
    Set objViews = Application.Views
    'Create the Groups object
    Set objGrp = objViews.Create(3, "GV")
    'Add a Group -NoEmail and Get its uniqueId into TempGrp
    objGrp.AddNew
    objGrp.SetField 25, "NoEmail"
    TempGrp = objGrp.GetField(1)
    objGrp.Close
    'Now Group View is closed

    'Create the Contact View and Create a lookup of all contacts
    Set objContact = objViews.Create(1, "CV")
    objContact.LookupALL
    objContact.MoveFirst
    'Go through all the Contacts , 
    'if Email Address field is blank then add to Group -NoEmail
    For i = 1 To objContact.GetCount
    	If objContact.GetField(200) = "" Then
        	objContact.AddContactToGroup TempGrp
    	End If
    	objContact.MoveNext
    Next 

    MsgBox "All Contacts without Email addresses have been placed in Group NoEmail" & vbCrLf & "Setting the lookup to Group- NoEmail"
    'Create a Lookup of Group NoEmail
    objContact.SetActiveGroup TempGrp  

    'Releasing all objects
    Set objGrp = Nothing
    Set objContact = Nothing
    Set objViews = Nothing