VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Contacts Sample"
   ClientHeight    =   4725
   ClientLeft      =   915
   ClientTop       =   1290
   ClientWidth     =   6690
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4725
   ScaleWidth      =   6690
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdDspMyRec 
      Caption         =   "Display My Record"
      Height          =   372
      Left            =   120
      TabIndex        =   14
      Top             =   4200
      Width           =   1572
   End
   Begin VB.CommandButton cmdListNotes 
      Caption         =   "List Note/History"
      Height          =   372
      Left            =   5040
      TabIndex        =   13
      Top             =   3240
      Width           =   1332
   End
   Begin VB.CommandButton cmdAddNote 
      Caption         =   "Add a Note"
      Height          =   372
      Left            =   3480
      TabIndex        =   12
      Top             =   4200
      Width           =   1212
   End
   Begin VB.CommandButton cmdSort 
      Caption         =   "Sort"
      Height          =   372
      Left            =   2040
      TabIndex        =   11
      Top             =   4200
      Width           =   1092
   End
   Begin VB.CommandButton cmdListActivities 
      Caption         =   "List Activities"
      Height          =   372
      Left            =   5040
      TabIndex        =   10
      Top             =   3720
      Width           =   1332
   End
   Begin VB.CommandButton cmdFieldSchema 
      Caption         =   "Field Schema List"
      Height          =   372
      Left            =   120
      TabIndex        =   9
      Top             =   3720
      Width           =   1572
   End
   Begin VB.CommandButton cmdReload 
      Caption         =   "Reload Database"
      Height          =   372
      Left            =   5040
      TabIndex        =   8
      Top             =   120
      Width           =   1452
   End
   Begin VB.CommandButton CmdQuery 
      Caption         =   "Query"
      Height          =   372
      Left            =   2040
      TabIndex        =   7
      Top             =   3720
      Width           =   1092
   End
   Begin VB.CommandButton cmdLookUp 
      Caption         =   "LookUp"
      Height          =   372
      Left            =   2040
      TabIndex        =   6
      Top             =   3240
      Width           =   1092
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete Contact"
      Height          =   372
      Left            =   3480
      TabIndex        =   5
      Top             =   3720
      Width           =   1212
   End
   Begin VB.CommandButton CmdAdd 
      Caption         =   "Add a Contact"
      Height          =   372
      Left            =   3480
      TabIndex        =   4
      Top             =   3240
      Width           =   1212
   End
   Begin VB.CommandButton cmdListContacts 
      Caption         =   "List All Contacts"
      Height          =   372
      Left            =   120
      TabIndex        =   3
      Top             =   3240
      Width           =   1572
   End
   Begin VB.TextBox txtDBName 
      Height          =   288
      Left            =   240
      TabIndex        =   2
      Top             =   84
      Width           =   3132
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   372
      Left            =   5040
      TabIndex        =   1
      Top             =   4200
      Width           =   1332
   End
   Begin VB.ListBox lstDisplay 
      Height          =   2205
      ItemData        =   "ContactMain.frx":0000
      Left            =   120
      List            =   "ContactMain.frx":0002
      TabIndex        =   0
      Top             =   600
      Width           =   6372
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub CmdAdd_Click()
'The following Code adds a contact into the ACT Database"

Dim objDatabase As Object
Dim lcounter As Long
Dim x As Long
Dim bReturn As Boolean
Dim szUniqueID As String
   
    b40Data = False
   
    lstDisplay.Clear
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
   
    ' perform login validation
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
        
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
         'if Version of the database object > 3 (4.0 or greater) then check the version of the database
         If (Val(objDatabase.Version) > 3) Then
            If (Val(objDatabase.DatabaseVersion) > 3) Then
            'Ticker Symbol Field is available only in ACT4.0 database
                b40Data = True
            End If
         End If
         
        ' display the add new contact dialog
        bOK = False
        frmAddContact.Show 1
         'If user exits from the add new contact dialog
        'with a Cancel then exit this sub now.
        If Not bOK Then
            Exit Sub
        End If
        
        lstDisplay.AddItem "There are " & objDatabase.CONTACT.recordCount & " contacts in this database."
        objDatabase.PhoneFormatting = 1 ' free form phone entry
        objDatabase.CONTACT.MoveFirst
              
        ' allocate a new record
        objDatabase.CONTACT.Add
                           
        ' set field data with the information in the AddContact Form
        objDatabase.CONTACT.Data CF_PublicPrivate, 2    ' make it private
        objDatabase.CONTACT.Data CF_Salutation, frmAddContact.txtSalutation.Text
        objDatabase.CONTACT.Data CF_Company, frmAddContact.txtCompany
        objDatabase.CONTACT.Data CF_Name, frmAddContact.txtContact
        objDatabase.CONTACT.Data CF_Address1, frmAddContact.txtAddress
        objDatabase.CONTACT.Data CF_Address2, frmAddContact.txtAddress2
        objDatabase.CONTACT.Data CF_City, frmAddContact.txtCity
        objDatabase.CONTACT.Data CF_State, frmAddContact.txtState
        objDatabase.CONTACT.Data CF_Zip, frmAddContact.txtZip
        objDatabase.CONTACT.Data CF_Title, frmAddContact.txtTitle
        objDatabase.CONTACT.Data CF_Phone, frmAddContact.txtPhone
        
        If b40Data = True Then
            'Ticker Symbol Field is available only in ACT4.0 database
            objDatabase.CONTACT.Data CF_TickerSymbol, frmAddContact.txtTickerSymbol
        End If
        
        lstDisplay.AddItem "New Contact has been added!"
        
        ' update the records contents
        szUniqueID = objDatabase.CONTACT.Update
        objDatabase.CONTACT.GoTo (szUniqueID)   ' reposition to new record
        
        lstDisplay.AddItem ""
        lstDisplay.AddItem "Here is where we are: " & objDatabase.CONTACT.Data(CF_Name)
        Set objContact = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub cmdAddNote_Click()
'Following code adds a note for a particular contact

  Dim objDatabase As Object
  Dim lcounter As Long
  Dim strContactId As String
  Dim iPosition As Integer
  
    ' bring up the contact chooser
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        MsgBox "No Contact Selected"
        Exit Sub ' return without doing anything
    End If
    
    'Parse the Contact Unique Id
    iPosition = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    strContactId = Left$(frmContactPicker.lstPicker.Text, iPosition - 1)
    
    ' display the add new note dialog
    bOK = False
    frmAddNote.Show 1
    If Not bOK Then
        MsgBox "No Note to Add"
        Exit Sub
    End If
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    If objDatabase.IsOpen Then
        lstDisplay.AddItem ""
        
        ' allocate a new record
        objDatabase.NOTEHISTORY.Add
        
        ' set field data
        objDatabase.NOTEHISTORY.Data NHF_ContactId, strContactId
        objDatabase.NOTEHISTORY.Data NHF_Text, frmAddNote.txtNote.Text
                                 
        ' update the records contents
        objDatabase.NOTEHISTORY.Update
        
        Set objContact = Nothing
        lstDisplay.AddItem ""
        lstDisplay.AddItem "Note has been added!!!"
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    ' clear the object
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub cmdDelete_Click()
'Code to Delete a Contact from a database

Dim objDatabase As Object
Dim lcounter As Long
Dim strContactId As String
Dim iPosition As Integer
Dim objContact As Object
Dim iStyle As Integer
Dim strMsg As String
Dim strTitle As String
Dim strResponse As String
  
    ' bring up the table chooser
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        MsgBox "No Contact Selected"
        Exit Sub ' return without doing anything
    End If
    
    'Get the Contacts Unique ID
    iPosition = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    strContactId = Left$(frmContactPicker.lstPicker.Text, iPosition - 1)
        
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the object
    Set objContact = objDatabase.CONTACT
    If objDatabase.IsOpen Then
               
        lstDisplay.AddItem "Record Count = " & objContact.recordCount
        lstDisplay.AddItem " "
        
        ' seek to that contact
        objContact.GoTo (strContactId)
        
        'Bring up a message box to confirm deletion of the contact
        iStyle = vbYesNo + vbCritical + vbDefaultButton2
        strMsg = "Are you sure you want to delete: [" & frmContactPicker.lstPicker.Text & "] (Y/N)"
        strTitle = "Delete Contact"
        strResponse = MsgBox(strMsg, iStyle, strTitle)
        
        If strResponse = vbYes Then    ' User chose Yes.
            lstDisplay.AddItem "Contact item: " & frmContactPicker.lstPicker.Text & " has been deleted!"
            objContact.Delete
            lstDisplay.AddItem "Record Count = " & objContact.recordCount
            'The ContactPicker Form contents need to be reloaded
            Unload frmContactPicker
            frmContactPicker.Hide
        Else    ' User chose No.
            lstDisplay.AddItem "Contact item: " & frmContactPicker.lstPicker.Text & " Not deleted!"
        End If
                       
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        Set objContact = Nothing
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub


Private Sub cmdDspMyRec_Click()
    ' code to list My Record
    Dim objDatabase As Object
    Dim objContact As Object
    Dim objUser As Object
    Dim lcounter As Long
    Dim strMe As String
    Dim iUserCount As Integer
    Dim i As Integer
    Dim strContactId As String
    Dim iLength As Integer
      
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    If objDatabase.MajorVersion = 1 Then  'ACTOLE.dll version is older than 3.06
             MsgBox "You have an ACTOLE.dll older than version 3.06." & Chr(13) & "Please Update!"
    End If
        
    'strMe will have the current users Logon
    strMe = objDatabase.CurrentUser
    
    'Set the objects
    Set objUser = objDatabase.Users
    Set objContact = objDatabase.CONTACT
        
    i = 1
    If objDatabase.IsOpen Then
        iUserCount = objUser.Count
        While i <= iUserCount
            'If strMe is same as the user Name then get the users Unique ID
            If strMe = objUser.Name(i) Then
                strContactId = objUser.uniqueID(i)
            End If
            i = i + 1
        Wend
        'Now go through all the contacts till the strContactID matches the
        'unique ID .
        objDatabase.PhoneFormatting = 3
        objContact.MoveFirst
        While Not objContact.IsEOF
            'List Information from all the fields within the Contact Record
            If (strContactId = objContact.Data(CF_UniqueID)) Then
                lstDisplay.AddItem "My Record is as Follows:"
                lstDisplay.AddItem ""
                If objDatabase.MajorVersion <> 1 Then   'Actole.dll version is 3.06 or later
                    For lcounter = 1 To objContact.FIELDS.Count
                    fid = objContact.FIELDS.FieldIdAt(lcounter)
                    iLength = Len(objContact.Data(fid))
                        If (iLength > 0) Then
                            lstDisplay.AddItem objContact.FIELDS.Label(fid) & " : " & objContact.Data(objContact.FIELDS.FieldIdAt(lcounter))
                        End If
                    Next
                Else           'Actole.dll is older than 3.06
                    lstDisplay.AddItem "My Name :" & objContact.Data(CF_Name)
                    lstDisplay.AddItem "My Name :" & objContact.Data(CF_Company)
                    lstDisplay.AddItem "Title   :" & objContact.Data(CF_Company)
                    lstDisplay.AddItem "Address :" & objContact.Data(CF_Address1)
                    lstDisplay.AddItem "        :" & objContact.Data(CF_City)
                    lstDisplay.AddItem "        :" & objContact.Data(CF_State) & " " & objContact.Data(CF_Zip)
                    lstDisplay.AddItem "Phone   :" & objContact.Data(CF_Phone)
                End If
            End If
            objContact.MoveNext
         Wend
         
         Set objContact = Nothing
         Set objUser = Nothing
         lstDisplay.AddItem " "
         lstDisplay.AddItem "Closing Database"
         objDatabase.Close
         lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
    
End Sub

Private Sub cmdExit_Click()
  End
End Sub


Private Sub cmdListActivities_Click()
'This Function lists all the activities for a particular contact

Dim objDatabase As Object
Dim lcounter As Long
Dim strContactId As String
Dim iPosition As Integer
Dim objActivity As Object
  
    ' bring up the table chooser
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        Exit Sub ' return without doing anything
    End If
    'Parse the select list Text to get only the Contact Unique Id
    iPosition = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    strContactId = Left$(frmContactPicker.lstPicker.Text, iPosition - 1)
    
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    Set objActivity = objDatabase.ACTIVITY
    If objDatabase.IsOpen Then
        'Set the Scope to activities of selected contact
        objActivity.SetContactScope strContactId
        objActivity.MoveFirst
        While Not objActivity.IsEOF
            lstDisplay.AddItem "ACTIVITY Regarding   : " & objActivity.Data(AF_Regarding)
            lstDisplay.AddItem "ACTIVITY Start Time  : " & objActivity.Data(AF_StartTime)
            lstDisplay.AddItem "ACTIVITY End Time    : " & objActivity.Data(AF_EndTime)
            objActivity.MoveNext
        Wend
        
        Set objActivity = Nothing
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub cmdListContacts_Click()
    ' code to list all the contacts
    Dim objDatabase As Object
    Dim objContact As Object
    Dim lcounter As Long
    Dim strOutput As String
      
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    Set objContact = objDatabase.CONTACT
    If objDatabase.IsOpen Then
        lstDisplay.AddItem "There are " & objContact.recordCount & " contacts in this database."
        lstDisplay.AddItem " "
        ' enumerate all contacts in this group
        If objContact.recordCount > 0 Then
            objContact.MoveFirst
            While Not objContact.IsEOF
                  lstDisplay.AddItem objContact.Data(CF_Name)
                  objContact.MoveNext
            Wend
        End If
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        Set objContact = Nothing
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
    
End Sub




Private Sub cmdListNotes_Click()
'The following code list the Notes and History for a partcular contact

   Dim objDatabase As Object
   Dim objNoteHistory As Object
   Dim lcounter As Long
   Dim strContactId As String
   Dim iPosition As Integer
   Dim strUniqueID As String
      
    ' bring up the table chooser
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        MsgBox "No Contact Selected"
        Exit Sub ' return without doing anything
    End If
    
    'Parse the listbox Text to get only the Contact UniqueId
    iPosition = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    strContactId = Left$(frmContactPicker.lstPicker.Text, iPosition - 1)
    
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
    ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    Set objNoteHistory = objDatabase.NOTEHISTORY
    
    If objDatabase.IsOpen Then
    'List the Note/History Records for the contact strContactId
    objNoteHistory.SetContactScope strContactId
        objNoteHistory.MoveFirst
        While Not objNoteHistory.IsEOF
                lstDisplay.AddItem "NOTE (regarding): " & objNoteHistory.Data(NHF_Text)
                lstDisplay.AddItem "NOTE (BLOB): " & objNoteHistory.Data(NHF_Attachment)
                objNoteHistory.MoveNext
        Wend
        
        Set objNoteHistory = Nothing
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub cmdLookUp_Click()
'Perform Lookup on the Contacts Table

  Dim objDatabase As Object
  Dim objContact As Object
  Dim lcounter As Long
  Dim strLookup As String
  Dim isearchField As Integer
  isearchField = CF_Name 'default
  
    ' bring up the lookup form
    bOK = False
    frmLookup.Show 1
    If Not bOK Then
        strLookup = ""
    End If
    strLookup = frmLookup.txtLookupString   'get the lookup string

    'Get the Search field for the lookup
    If frmLookup.cbolookupField = "FULL NAME" Then
        isearchField = CF_Name
    End If
    If frmLookup.cbolookupField = "FIRST NAME" Then
        isearchField = CF_FirstName
    End If
    If frmLookup.cbolookupField = "LAST NAME" Then
        isearchField = CF_LastName
    End If
    If frmLookup.cbolookupField = "COMPANY" Then
        isearchField = CF_Company
    End If
    If frmLookup.cbolookupField = "TITLE" Then
        isearchField = CF_Title
    End If
        
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    Set objContact = objDatabase.CONTACT
    If objDatabase.IsOpen Then
        'Lookup
        objContact.Lookup isearchField, strLookup, 1
        lstDisplay.AddItem objContact.recordCount & " Records Found!"
        lstDisplay.AddItem " "
        
        ' enumerate records in the contact table
        objContact.MoveFirst
        While Not objContact.IsEOF
            'To list the phone records in ACT displayable format with country code
            objDatabase.PhoneFormatting = 3
     
            lstDisplay.AddItem "CONTACT: " & objContact.Data(CF_Name)
            lstDisplay.AddItem "TITLE:   " & objContact.Data(CF_Title)
            lstDisplay.AddItem "COMPANY: " & objContact.Data(CF_Company)
            lstDisplay.AddItem "ADDRESS: " & objContact.Data(CF_Address1)
            lstDisplay.AddItem "         " & objContact.Data(CF_City) & ", " & objContact.Data(CF_State) & objContact.Data(CF_Zip)
            lstDisplay.AddItem "PHONE:   " & objContact.Data(CF_Phone)
            lstDisplay.AddItem "----------------------------"
                
            objContact.MoveNext
        Wend
        
        Set objContact = Nothing
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objData = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub CmdQuery_Click()
'Function to Run Queries.
'It requires the user to enter any number of Alphabets in the Name of
'the Contact to run a Search on. For example "Ja" will list
'Jack Nickolson and James Black.

Dim objDatabase As Object
Dim objContact As Object
Dim lcounter As Long
Dim strQuery As String
Dim strQueryStatement As String
           
    ' clear the listbox
    lstDisplay.Clear
    
    bOK = False
    frmQuery.Show 1
    If Not bOK Then
        MsgBox "No String Entered to find"
        Exit Sub
    End If
    strQuery = """" & frmQuery.txtQueryString.Text & """"
    
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    ' assign the correct table object
    
    Set objContact = objDatabase.CONTACT
    If objDatabase.IsOpen Then
        ' Form the Query statement
        strQueryStatement = "CONTACT contains " & strQuery
        
        'run the Query in the format "CONTACT contains ""Jeff"""
        objContact.Query = strQueryStatement
        objContact.Execute   'Execute needs to be called after setting the query
        
        lstDisplay.AddItem objContact.recordCount & " Records Found!"
        lstDisplay.AddItem " "
        
        ' enumerate all of the records in the contact table
        objContact.MoveFirst
        While Not objContact.IsEOF
            lstDisplay.AddItem "CONTACT: " & objContact.Data(CF_Name)
            lstDisplay.AddItem "TITLE:   " & objContact.Data(CF_Title)
            lstDisplay.AddItem "COMPANY: " & objContact.Data(CF_Company)
            lstDisplay.AddItem "----------------------------"
            objContact.MoveNext
        Wend
        lstDisplay.AddItem " "
        Set objContact = Nothing
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objData = Nothing
    lstDisplay.SetFocus

End Sub

Private Sub cmdReload_Click()
     'This function reloads the database if
     'the database is changed by the user
     
    dbName = txtDBName.Text
    MsgBox "The database has changed"
    
    'The Contact Picker form needs to be reloaded
    Unload frmContactPicker
    frmContactPicker.Hide
    
End Sub


Private Sub cmdSort_Click()
'Function to sort the Contact Table.

 Dim objDatabase As Object
 Dim objContact As Object
 Dim lcounter As Long
    
 Dim iSortFld1 As Integer
 Dim iSortfld2 As Integer
 Dim iSortfld3 As Integer
    
 Dim iSortOrder1 As Integer
 Dim iSortOrder2 As Integer
 Dim iSortorder3 As Integer
 
 Dim iPrevSortFld1 As Integer
 Dim iPrevSortfld2 As Integer
 Dim iPrevSortfld3 As Integer
    
 Dim iPrevSortOrder1 As Integer
 Dim iPrevSortOrder2 As Integer
 Dim iPrevSortorder3 As Integer
  
 'Default sort fields
 iSortFld1 = 0
 iSortfld2 = 0
 iSortfld3 = 0
    
 'Default Sort Order to Ascending
 iSortOrder1 = 0
 iSortOrder2 = 0
 iSortorder3 = 0
  
    ' bring up the table chooser
    bOK = False
    frmSort.Show 1
    If Not bOK Then
        MsgBox "OK not selected,Sorting will not be done!"
        Exit Sub
    End If
    
    If frmSort.cbosortFld1 = "FULL NAME" Then
        iSortFld1 = CF_Name
    End If
    If frmSort.cbosortFld1 = "FIRST NAME" Then
        iSortFld1 = CF_FirstName
    End If
    If frmSort.cbosortFld1 = "LAST NAME" Then
        iSortFld1 = CF_LastName
    End If
    If frmSort.cbosortFld1 = "COMPANY" Then
        iSortFld1 = CF_Company
    End If
    If frmSort.cbosortFld1 = "TITLE" Then
        iSortFld1 = CF_Title
    End If
    
    If frmSort.cbosortFld2 = "(NONE)" Then
        iSortfld2 = 0
    End If
    If frmSort.cbosortFld2 = "FULL NAME" Then
        iSortfld2 = CF_Name
    End If
    If frmSort.cbosortFld2 = "FIRST NAME" Then
        iSortfld2 = CF_FirstName
    End If
    If frmSort.cbosortFld2 = "LAST NAME" Then
        iSortfld2 = CF_LastName
    End If
    If frmSort.cbosortFld2 = "COMPANY" Then
        iSortfld2 = CF_Company
    End If
    If frmSort.cbosortFld2 = "TITLE" Then
        iSortfld2 = CF_Title
    End If
    
    If frmSort.cbosortFld3 = "(NONE)" Then
        iSortfld3 = 0
    End If
    If frmSort.cbosortFld3 = "FULL NAME" Then
        iSortfld3 = CF_Name
    End If
    If frmSort.cbosortFld3 = "FIRST NAME" Then
        iSortfld3 = CF_FirstName
    End If
    If frmSort.cbosortFld3 = "LAST NAME" Then
        iSortfld3 = CF_LastName
    End If
    If frmSort.cbosortFld3 = "COMPANY" Then
        iSortfld3 = CF_Company
    End If
    If frmSort.cbosortFld3 = "TITLE" Then
        iSortfld3 = CF_Title
    End If

'Get the SortOrder
     If frmSort.optAscending1.Value = True Then
        iSortOrder1 = 0      'Ascending
     Else
        iSortOrder1 = 1      'Descending
     End If
     If frmSort.optAscending2.Value = True Then
        iSortOrder2 = 0        'Ascending
     Else
        iSortOrder2 = 1        'Descending
     End If
     If frmSort.optAscending3.Value = True Then
        iSortorder3 = 0         'Ascending
     Else
        iSortorder3 = 1         'Descending
     End If

    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation -
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    
    Set objContact = objDatabase.CONTACT
    If objDatabase.IsOpen Then
        If Val(objDatabase.Version) > 3 Then
            objContact.GetSort iPrevSortFld1, iPrevSortOrder1, iPrevSortfld2, iPrevSortOrder2, iPrevSortfld3, iPrevSortorder3
            lstDisplay.AddItem "Current Sort Order is : " & iPrevSortFld1 & " | " & iPrevSortOrder1 & " | " & iPrevSortfld2 & " | " & iPrevSortOrder2 & " | " & iPrevSortfld3 & " | " & iPrevSortorder3
        End If
        objContact.Sort iSortFld1, iSortOrder1, iSortfld2, iSortOrder2, iSortfld3, iSortorder3
        
        lstDisplay.AddItem objContact.recordCount & " Records Sorted!"
        lstDisplay.AddItem "Sort Order = " & frmSort.cbosortFld1 & " | " & frmSort.cbosortFld2 & " | " & frmSort.cbosortFld3
        lstDisplay.AddItem " "
        ' enumerate all of the records in the contact table
        objContact.MoveFirst
        While Not objContact.IsEOF
            lstDisplay.AddItem "CONTACT: " & objContact.Data(CF_Name)
            lstDisplay.AddItem "TITLE:   " & objContact.Data(CF_Title)
            lstDisplay.AddItem "COMPANY: " & objContact.Data(CF_Company)
            lstDisplay.AddItem "----------------------------"
            objContact.MoveNext
        Wend
        lstDisplay.AddItem " "
        
        Set objContact = Nothing
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub



Private Sub Form_Load()
    dbName = "C:\PROGRAM FILES\ACT\DATABASE\ACT5DEMO.DBF"
    txtDBName.Text = dbName
    bAlreadyLoggedIn = False
End Sub











Private Sub cmdFieldSchema_Click()
'This function lists the field schema for all the fields
'in the Contact Object
 Dim objDatabase As Object
 Dim objContact As Object
 Dim lcounter As Long
 Dim strOut As String
 Dim iFieldID As Integer
 
    lstDisplay.Clear
    lstDisplay.AddItem "*** Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
                
    lstDisplay.AddItem "*** Opening Database"
    objDatabase.Open dbName
    lstDisplay.AddItem "*** Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
                
    ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    'Check if version of the ACTOLE.dll is  3.06 or greater (3.05 returns a 1 )
    If objDatabase.MajorVersion = 1 Then
            MsgBox "You have an ACTOLE.dll older than version 3.06." & Chr(13) & "This function needs the new features. Please Update and Retry!  "
            lstDisplay.Clear
            objDatabase.Close
            Exit Sub
    End If
    If objDatabase.IsOpen Then
       
    ' assign the object
        Set objContact = objDatabase.CONTACT
        lstDisplay.AddItem "Name: " & objDatabase.Name
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Record count: " & objContact.recordCount
        lstDisplay.AddItem "Field Count : " & objContact.FieldCount
        lstDisplay.AddItem "Table Name : " & objContact.Name
        lstDisplay.AddItem ""
    
        For lcounter = 1 To objContact.FIELDS.Count()
            'List all properties for each field
            strOut = ""
                                            
            If (objContact.FIELDS.FieldIdAt(lcounter) <> -1) Then
                iFieldID = objContact.FIELDS.FieldIdAt(lcounter)
                strOut = strOut + "* Field " & ": " & " FIELD ID=" & objContact.FIELDS.FieldIdAt(lcounter)
                strOut = strOut + " " & "Label=" & objContact.FIELDS.Label(iFieldID)
                strOut = strOut + ", Type: " & objContact.FIELDS.Type(iFieldID)
                strOut = strOut + ", Length: " & objContact.FIELDS.length(iFieldID)
                         
                lstDisplay.AddItem strOut
                strOut = ""
                strOut = strOut + "   Indexed:" & objContact.FIELDS.IsIndexed(iFieldID)
                strOut = strOut + ", Initial Value:" & objContact.FIELDS.InitialValue(iFieldID)
                strOut = strOut + ", Sortable:" & objContact.FIELDS.IsSortable(iFieldID)
                strOut = strOut + ", Modifiable:" & objContact.FIELDS.Modifiable(iFieldID)
                strOut = strOut + ", PopupList:" & objContact.FIELDS.HasPopupList(iFieldID)
                lstDisplay.AddItem strOut
                         
                strOut = ""
                strOut = strOut + "   EntryTrigger=" & objContact.FIELDS.EntryTrigger(iFieldID)
                strOut = strOut + ", ExitTrigger=" & objContact.FIELDS.ExitTrigger(iFieldID)
                lstDisplay.AddItem strOut
                lstDisplay.AddItem ""
            End If
        Next
        Set objContact = Nothing
        lstDisplay.AddItem "*** Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "*** Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub


