VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5130
   ClientLeft      =   615
   ClientTop       =   1740
   ClientWidth     =   7530
   LinkTopic       =   "Form1"
   ScaleHeight     =   5130
   ScaleWidth      =   7530
   Begin VB.Frame Frame3 
      Caption         =   "ACT! Database to open"
      Height          =   615
      Left            =   120
      TabIndex        =   10
      Top             =   4440
      Width           =   7215
      Begin VB.TextBox txtdbName 
         Height          =   285
         Left            =   120
         TabIndex        =   11
         Text            =   "c:\Program Files\ACT\Database\act5demo.dbf"
         Top             =   240
         Width           =   4335
      End
   End
   Begin VB.CommandButton cmdReopen 
      Caption         =   "Re-Open Sale"
      Height          =   375
      Left            =   2280
      TabIndex        =   8
      Top             =   3840
      Width           =   1695
   End
   Begin VB.CommandButton cmdComplete 
      Caption         =   "Complete Sale "
      Height          =   375
      Left            =   2280
      TabIndex        =   7
      Top             =   3360
      Width           =   1695
   End
   Begin VB.CommandButton cmdAddType 
      Caption         =   "Add a Type"
      Height          =   375
      Left            =   240
      TabIndex        =   6
      Top             =   3360
      Width           =   1695
   End
   Begin VB.CommandButton cmdAddCompetitor 
      Caption         =   "Add a Competitor"
      Height          =   375
      Left            =   240
      TabIndex        =   5
      Top             =   3840
      Width           =   1695
   End
   Begin VB.CommandButton cmdListSales 
      Caption         =   "List All Sales"
      Height          =   375
      Left            =   4680
      TabIndex        =   4
      Top             =   2880
      Width           =   2175
   End
   Begin VB.CommandButton cmdAddProduct 
      Caption         =   "Add a Product"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   2880
      Width           =   1695
   End
   Begin VB.CommandButton cmdAddSale 
      Caption         =   "New Sales Forecast"
      Height          =   375
      Left            =   2280
      TabIndex        =   2
      Top             =   2880
      Width           =   1695
   End
   Begin VB.Frame Frame1 
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   7215
      Begin VB.ListBox lstDisplay 
         Height          =   1815
         ItemData        =   "SalesMain.frx":0000
         Left            =   120
         List            =   "SalesMain.frx":0002
         TabIndex        =   1
         Top             =   360
         Width           =   6855
      End
   End
   Begin VB.Frame Frame2 
      Height          =   1695
      Left            =   120
      TabIndex        =   9
      Top             =   2640
      Width           =   7215
      Begin VB.CommandButton cmdListGroupSales 
         Caption         =   "List Sales for a Group"
         Height          =   375
         Left            =   4560
         TabIndex        =   13
         Top             =   1200
         Width           =   2175
      End
      Begin VB.CommandButton cmdListContactSales 
         Caption         =   "List Sales for a Contact"
         Height          =   375
         Left            =   4560
         TabIndex        =   12
         Top             =   720
         Width           =   2175
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cmdAddCompetitor_Click()
'Add a Competitor and then list all the competitor types
Dim objDatabase As Object
Dim objList As Object
Dim sEntry As String


    Dim lcounter As Long
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation - nothing really happens
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    
    sEntry = InputBox("Please enter the Competitor Name", "Add a Competitor", "ABC Company")
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        Set objList = objDatabase.ListTable
        objList.Add
        objList.Data LTF_Type, 3   ' Type 3 is a competitor
        objList.Data LTF_Name, sEntry  'Competitor Name
        objList.Update
        
       'List all the products in the List Table
        objList.SetScope 3
        lstDisplay.AddItem ""
        lstDisplay.AddItem "List of Competitors are :"
        lstDisplay.AddItem "---------------------------------"
         For lcounter = 1 To objList.RecordCount
            lstDisplay.AddItem objList.Data(LTF_Name)
            objList.MoveNext
        Next lcounter
        lstDisplay.AddItem "---------------------------------"
        lstDisplay.AddItem ""
        Set objList = Nothing
        objDatabase.Close
      End If
        lstDisplay.AddItem "Closing Database"
        Set objDatabnase = Nothing
        lstDisplay.AddItem "Database Closed"
        lstDisplay.SetFocus
    
End Sub

Private Sub cmdAddProduct_Click()
'Adds a product and then lists all the products in the list Table
Dim objDatabase As Object
Dim objList As Object
Dim sEntry As String


    Dim lcounter As Long
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation - nothing really happens
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    
    sEntry = InputBox("Please enter the product Name", "Add a Product", "My Product")
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        'Create the List Table object
        Set objList = objDatabase.ListTable
        'Add a Product
        objList.Add
        objList.Data LTF_Type, 1   ' Type 1 is a product
        objList.Data LTF_Name, sEntry    'Product Name
        objList.Update
        
        'List all the products in the List Table
        objList.SetScope 1
        lstDisplay.AddItem ""
        lstDisplay.AddItem "List of Products are :"
        lstDisplay.AddItem "---------------------------------"
         For lcounter = 1 To objList.RecordCount
            lstDisplay.AddItem objList.Data(LTF_Name)
            objList.MoveNext
        Next lcounter
        lstDisplay.AddItem ""
        lstDisplay.AddItem "---------------------------------"
        Set objList = Nothing
        objDatabase.Close
      End If
        lstDisplay.AddItem "Closing Database"
        Set objDatabnase = Nothing
        lstDisplay.AddItem "Database Closed"
        lstDisplay.SetFocus
   
    
End Sub

Private Sub cmdAddSale_Click()
'The following code creates a new sales forecast.
Dim objDatabase As Object
Dim objSales As Object
    Dim lcounter As Long
    
    ' display the new Sale dialog
    bOK = False
    frmNewSale.Show 1
    If Not bOK Then
        Exit Sub
    End If
    
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        'Create a Sales object
        Set objSales = objDatabase.Sales
        ' allocate a new record
        objSales.Add
                    
        '------------------------------------------
        ' set the TIME FIELDS (critical formatting required)
        '------------------------------------------
        
        Dim closedate, startDate As String
        Dim timestring As String
        'Format the close date
        closedate = DateValue(frmNewSale.txtCloseDate.Text)
        startDate = DateValue(Now) 'start date = todays date
        
        'Set the data
        objSales.Data SLF_SaleStartDate, startDate 'start date
        objSales.Data SLF_SaleDate, closedate  'close date
        
       
        objSales.Data SLF_ProductId, frmNewSale.txtProduct
        objSales.Data SLF_TypeId, frmNewSale.txtType
        objSales.Data SLF_Units, Val(frmNewSale.txtQuantity)
        objSales.Data SLF_UnitPrice, Val(frmNewSale.txtUPrice)
        objSales.Data SLF_Amount, (Val(frmNewSale.txtUPrice) * Val(frmNewSale.txtQuantity)) 'Calculate the total amount of the sale
        objSales.Data SLF_CompetitorsId, frmNewSale.txtCompetitor
        objSales.Data SLF_Probability, frmNewSale.txtProb
        objSales.Data SLF_SalesStage, frmNewSale.txtStage
        
        
        ' update the records contents
        Dim uniqueID As String
        uniqueID = objSales.Update
        If objSales.Error Then
            MsgBox objSales.LastError
        End If
        
        objSales.GoTo (uniqueID)
        ' make the association between a contact and the sale
        objSales.AssociateWithContact (frmNewSale.txtContact)
      
        lstDisplay.AddItem ""
        lstDisplay.AddItem "*** Sale Added!!!"
        lstDisplay.AddItem ""
        Unload frmNewSale
        If objSales.Error Then
            MsgBox objSales.LastError
        End If
         
        Set objSales = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub

Private Sub cmdAddType_Click()
'Add a Product Type and then list all the Product types
Dim objDatabase As Object
Dim objList As Object
Dim sEntry As String


    Dim lcounter As Long
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation - nothing really happens
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    
    sEntry = InputBox("Please enter the product type", "Add a Type", "Type C")
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        Set objList = objDatabase.ListTable
        objList.Add
        objList.Data LTF_Type, 2   ' Type 2 is a type
        objList.Data LTF_Name, sEntry  'Product Type
        objList.Update
        
        'List all the product  types in the List Table
        objList.SetScope 2
        lstDisplay.AddItem ""
        lstDisplay.AddItem "List of Product Types are :"
        lstDisplay.AddItem "---------------------------------"
       
         For lcounter = 1 To objList.RecordCount
            lstDisplay.AddItem objList.Data(LTF_Name)
            objList.MoveNext
        Next lcounter
        lstDisplay.AddItem "---------------------------------"
        lstDisplay.AddItem ""
        Set objList = Nothing
        objDatabase.Close
      End If
        lstDisplay.AddItem "Closing Database"
        Set objDatabnase = Nothing
        lstDisplay.AddItem "Database Closed"
        lstDisplay.SetFocus
        
       
    
End Sub


Private Sub cmdComplete_Click()
'The following code completes the first Sales oppoertunity in the database
    Dim objDatabase As Object
    Dim objSales As Object
    Dim lcounter As Long
    
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        'Create a Sales object
        Set objSales = objDatabase.Sales
        lstDisplay.AddItem " "
        objSales.MoveFirst
        While objSales.IsEOF <> True
            'Check if the first Sales Record is not complete ,
            'if complete move next until you find the first incomplete sale
            
            If objSales.Data(SLF_Status) = "Sales Opportunity" Then
                'Sale Information
                lstDisplay.AddItem "Product:  " & objSales.Data(SLVF_ProductName)
                lstDisplay.AddItem "Close Date: " & objSales.Data(SLF_SaleDate)
                lstDisplay.AddItem "Total Sale Amount :" & objSales.Data(SLF_Amount)
               
                'Complete the sale as Closed/Won sale
                objSales.CompleteSale 1, Now, "It was a Great deal"
                If objSales.Error Then
                    MsgBox objSales.LastError
                End If
                GoTo Proceed  ' Done with completing sale , exit the loop
            Else
                objSales.MoveNext
            End If
        Wend
     
Proceed:
       
        Set objSales = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub

Private Sub cmdListContactSales_Click()

'Lists all Sales associated with contact with the unique id ContactId
 Dim objDatabase As Object
 Dim objContact As Object
 Dim objSales As Object
 Dim lcounter As Long
 Dim contactID As String
 Dim position As Integer
      
    ' bring up the Contact Picker
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        Exit Sub ' return without doing anything
    End If
    

    position = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    contactID = Left$(frmContactPicker.lstPicker.Text, position - 1)
    
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        List1.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the sales object
   
    Set objSales = objDatabase.Sales
    Set objContact = objDatabase.Contact
    objContact.GoTo contactID
    lstDisplay.AddItem ""
    lstDisplay.AddItem " Sales Records for : " & objContact.Data(CF_Name)
    
    If objDatabase.IsOpen Then
       objSales.SetContactScope contactID ' Narrow the list of sales records to only those which belong to contact
       If objSales.Error Then MsgBox objSales.LastError
       
        lstDisplay.AddItem "Total Record Count = " & objSales.RecordCount
        lstDisplay.AddItem " "
        
        ' enumerate all of the records in the contact table
        objSales.MoveFirst
        While Not objSales.IsEOF
                    
                lstDisplay.AddItem "Product : " & objSales.Data(SLVF_ProductName)
                lstDisplay.AddItem " Close Date :" & objSales.Data(SLF_SaleDate)
                lstDisplay.AddItem " Total sale Amount : " & objSales.Data(SLF_Amount)
                   
                lstDisplay.AddItem "-------------"
                
            objSales.MoveNext
        Wend
                                 
        lstDisplay.AddItem " "
        Set objSales = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub

Private Sub cmdListGroupSales_Click()
'Lists all sales belonging to a group
Dim objDatabase As Object
Dim lcounter As Long
Dim groupUniqueID As String
Dim position As Integer
Dim objSales As Object
Dim objGroup As Object
    
    

    ' bring up the group picker
    bOK = False
    frmGroupPicker.Show 1
    If Not bOK Then
        Exit Sub ' return without doing anything
    End If
        
   
    position = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    groupUniqueID = Left$(frmGroupPicker.lstPicker.Text, position - 1)
    temp = groupUniqueID
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the sales object
   
    Set objSales = objDatabase.Sales
    
    If objDatabase.IsOpen Then
               
         lstDisplay.AddItem " "
        Set objGroup = objDatabase.Group
        objGroup.GoTo groupUniqueID
        
        lstDisplay.AddItem " Sales for Group : " & objGroup.Data(GF_Name)
      
        
        ' narrow the list of Sales record to those associated with the group
        objSales.SetGroupScope groupUniqueID
        objSales.MoveFirst
        lstDisplay.AddItem "Sales Record count : " & objSales.RecordCount
        lstDisplay.AddItem " "
        'Enumerate sales
        While Not objSales.IsEOF
                   
           
                lstDisplay.AddItem " Product :  " & objSales.Data(SLVF_ProductName)
                lstDisplay.AddItem " Close Date :" & objSales.Data(SLF_SaleDate)
                lstDisplay.AddItem " Total sale Amount : " & objSales.Data(SLF_Amount)
                   
                lstDisplay.AddItem "-------------"
                
            objSales.MoveNext
        Wend
                         
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub

Private Sub cmdListSales_Click()
' list all the Sales in the databse
    Dim objDatabase As Object
    Dim objSales As Object
    Dim lcounter As Long
  
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation routines
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    ' assign the correct table object
 
    Set objSales = objDatabase.Sales
    
    If objDatabase.IsOpen Then
                   
        
        lstDisplay.AddItem "Total Number of Sales Records in the database " & objSales.RecordCount
        lstDisplay.AddItem " "
        
        ' enumerate all of the  sales records
        objSales.MoveFirst
        
        
        While Not objSales.IsEOF
                                
                lstDisplay.AddItem " Product :  " & objSales.Data(SLVF_ProductName)
                lstDisplay.AddItem " Close Date :" & objSales.Data(SLF_SaleDate)
                lstDisplay.AddItem " Total sale Amount : " & objSales.Data(SLF_Amount)
                   
                lstDisplay.AddItem "-------------"
            objSales.MoveNext
        Wend
        
        Set objSales = Nothing
        objDatabase.Close
      End If
        lstDisplay.AddItem "Closing Database"
        Set objDatabnase = Nothing
        lstDisplay.AddItem "Database Closed"
        lstDisplay.SetFocus
End Sub

Private Sub cmdReopen_Click()
'Re-opens the first closed sale in the database
Dim objDatabase As Object
Dim objSales As Object

    Dim lcounter As Long
    
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        Set objSales = objDatabase.Sales
        
        objSales.MoveFirst
        'Re-open the first closed (Won or Lost) Sale in the database
        For lcounter = 1 To objSales.RecordCount
        If objSales.Data(SLF_Status) <> "Sales Opportunity" Then
         'if the sale is not an opportunity , Re-open it
                    
                'Sale Information
            lstDisplay.AddItem "Product:  " & objSales.Data(SLVF_ProductName)
            lstDisplay.AddItem "Close Date: " & objSales.Data(SLF_SaleDate)
            lstDisplay.AddItem "Total Sale Amount :" & objSales.Data(SLF_Amount)
            lstDisplay.AddItem "-------------------------"
             'Re-open the Sale
             objSales.ReopenSale
             If objSales.Error Then
                MsgBox objSales.LastError
            End If
          
            Exit For   'Done with Re-opening , Exit the For loop
         End If
         objSales.MoveNext
        Next lcounter
        
        Set objSales = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub


Private Sub Form_Load()
dbName = txtdbName.Text
Dim objDatabase As Object
Set objDatabase = CreateObject("ACTOLE.DATABASE")
If Val(objDatabase.Version) < 5 Then
    MsgBox " This sample requires  ACT!2000 (version 5) or later!!!"
    End
End If
Set objDatabase = Nothing
End Sub


Private Sub txtdbName_Change()
    dbName = txtdbName.Text
End Sub
